wxWidgets: wxWindow Class Reference

| Version: 3.0.4

Classes | Public Member Functions | Protected Member Functions | List of all members
wxWindow Class Reference
Class List by Category » Miscellaneous Windows

`#include </usr/src/ports/wxWidgets3.0/wxWidgets3.0-3.0.4-1.x86_64/src/wxWidgets-3.0.4/interface/wx/window.h>`

Inheritance diagram for wxWindow:
[legend]

## Detailed Description

wxWindow is the base class for all windows and represents any visible object on screen.

All controls, top level windows and so on are windows. Sizers and device contexts are not, however, as they don't appear on screen themselves.

Please note that all children of the window will be deleted automatically by the destructor before the window itself is deleted which means that you don't have to worry about deleting them manually. Please see the window deletion overview for more information.

Also note that in this, and many others, wxWidgets classes some `GetXXX()` methods may be overloaded (as, for example, wxWindow::GetSize or wxWindow::GetClientSize). In this case, the overloads are non-virtual because having multiple virtual functions with the same name results in a virtual function name hiding at the derived class level (in English, this means that the derived class has to override all overloaded variants if it overrides any of them). To allow overriding them in the derived class, wxWidgets uses a unique protected virtual `DoGetXXX()` method and all `GetXXX()` ones are forwarded to it, so overriding the former changes the behaviour of the latter.

## Styles

This class supports the following styles:

- wxBORDER_DEFAULT:
  The window class will decide the kind of border to show, if any.
- wxBORDER_SIMPLE:
  Displays a thin border around the window. wxSIMPLE_BORDER is the old name for this style.
- wxBORDER_SUNKEN:
  Displays a sunken border. wxSUNKEN_BORDER is the old name for this style.
- wxBORDER_RAISED:
  Displays a raised border. wxRAISED_BORDER is the old name for this style.
- wxBORDER_STATIC:
  Displays a border suitable for a static control. wxSTATIC_BORDER is the old name for this style. Windows only.
- wxBORDER_THEME:
  Displays a native border suitable for a control, on the current platform. On Windows XP or Vista, this will be a themed border; on most other platforms a sunken border will be used. For more information for themed borders on Windows, please see Themed borders on Windows.
- wxBORDER_NONE:
  Displays no border, overriding the default border style for the window. wxNO_BORDER is the old name for this style.
- wxBORDER_DOUBLE:
  This style is obsolete and should not be used.
- wxTRANSPARENT_WINDOW:
  The window is transparent, that is, it will not receive paint events. Windows only.
- wxTAB_TRAVERSAL:
  Use this to enable tab traversal for non-dialog windows.
- wxWANTS_CHARS:
  Use this to indicate that the window wants to get all char/key events for all keys - even for keys like TAB or ENTER which are usually used for dialog navigation and which wouldn't be generated without this style. If you need to use this style in order to get the arrows or etc., but would still like to have normal keyboard navigation take place, you should call Navigate in response to the key events for Tab and Shift-Tab.
- wxNO_FULL_REPAINT_ON_RESIZE:
  On Windows, this style used to disable repainting the window completely when its size is changed. Since this behaviour is now the default, the style is now obsolete and no longer has an effect.
- wxVSCROLL:
  Use this style to enable a vertical scrollbar. Notice that this style cannot be used with native controls which don't support scrollbars nor with top-level windows in most ports.
- wxHSCROLL:
  Use this style to enable a horizontal scrollbar. The same limitations as for wxVSCROLL apply to this style.
- wxALWAYS_SHOW_SB:
  If a window has scrollbars, disable them instead of hiding them when they are not needed (i.e. when the size of the window is big enough to not require the scrollbars to navigate it). This style is currently implemented for wxMSW, wxGTK and wxUniversal and does nothing on the other platforms.
- wxCLIP_CHILDREN:
  Use this style to eliminate flicker caused by the background being repainted, then children being painted over them. Windows only.
- wxFULL_REPAINT_ON_RESIZE:
  Use this style to force a complete redraw of the window whenever it is resized instead of redrawing just the part of the window affected by resizing. Note that this was the behaviour by default before 2.5.1 release and that if you experience redraw problems with code which previously used to work you may want to try this. Currently this style applies on GTK+ 2 and Windows only, and full repainting is always done on other platforms.

  ## Extra Styles

This class supports the following extra styles:

- wxWS_EX_VALIDATE_RECURSIVELY:
  By default, wxWindow::Validate(), wxWindow::TransferDataTo() and wxWindow::TransferDataFromWindow() only work on direct children of the window (compatible behaviour). Set this flag to make them recursively descend into all subwindows.
- wxWS_EX_BLOCK_EVENTS:
  wxCommandEvents and the objects of the derived classes are forwarded to the parent window and so on recursively by default. Using this flag for the given window allows to block this propagation at this window, i.e. prevent the events from being propagated further upwards. Dialogs have this flag on by default for the reasons explained in the Events and Event Handling.
- wxWS_EX_TRANSIENT:
  Don't use this window as an implicit parent for the other windows: this must be used with transient windows as otherwise there is the risk of creating a dialog/frame with this window as a parent, which would lead to a crash if the parent were destroyed before the child.
- wxWS_EX_CONTEXTHELP:
  Under Windows, puts a query button on the caption. When pressed, Windows will go into a context-sensitive help mode and wxWidgets will send a `wxEVT_HELP` event if the user clicked on an application window. This style cannot be used (because of the underlying native behaviour) together with `wxMAXIMIZE_BOX` or `wxMINIMIZE_BOX`, so these two styles are automatically turned off if this one is used.
- wxWS_EX_PROCESS_IDLE:
  This window should always process idle events, even if the mode set by wxIdleEvent::SetMode is `wxIDLE_PROCESS_SPECIFIED`.
- wxWS_EX_PROCESS_UI_UPDATES:
  This window should always process UI update events, even if the mode set by wxUpdateUIEvent::SetMode is `wxUPDATE_UI_PROCESS_SPECIFIED`.

  ## Events emitted by this class

Event macros for events emitted by this class:

- EVT_ACTIVATE(id, func):
  Process a `wxEVT_ACTIVATE` event. See wxActivateEvent.
- EVT_CHILD_FOCUS(func):
  Process a `wxEVT_CHILD_FOCUS` event. See wxChildFocusEvent.
- EVT_CONTEXT_MENU(func):
  A right click (or other context menu command depending on platform) has been detected. See wxContextMenuEvent.
- EVT_HELP(id, func):
  Process a `wxEVT_HELP` event. See wxHelpEvent.
- EVT_HELP_RANGE(id1, id2, func):
  Process a `wxEVT_HELP` event for a range of ids. See wxHelpEvent.
- EVT_DROP_FILES(func):
  Process a `wxEVT_DROP_FILES` event. See wxDropFilesEvent.
- EVT_ERASE_BACKGROUND(func):
  Process a `wxEVT_ERASE_BACKGROUND` event. See wxEraseEvent.
- EVT_SET_FOCUS(func):
  Process a `wxEVT_SET_FOCUS` event. See wxFocusEvent.
- EVT_KILL_FOCUS(func):
  Process a `wxEVT_KILL_FOCUS` event. See wxFocusEvent.
- EVT_IDLE(func):
  Process a `wxEVT_IDLE` event. See wxIdleEvent.
- EVT_JOY_*(func):
  Processes joystick events. See wxJoystickEvent.
- EVT_KEY_DOWN(func):
  Process a `wxEVT_KEY_DOWN` event (any key has been pressed). See wxKeyEvent.
- EVT_KEY_UP(func):
  Process a `wxEVT_KEY_UP` event (any key has been released). See wxKeyEvent.
- EVT_CHAR(func):
  Process a `wxEVT_CHAR` event. See wxKeyEvent.
- EVT_CHAR_HOOK(func):
  Process a `wxEVT_CHAR_HOOK` event. See wxKeyEvent.
- EVT_MOUSE_CAPTURE_LOST(func):
  Process a `wxEVT_MOUSE_CAPTURE_LOST` event. See wxMouseCaptureLostEvent.
- EVT_MOUSE_CAPTURE_CHANGED(func):
  Process a `wxEVT_MOUSE_CAPTURE_CHANGED` event. See wxMouseCaptureChangedEvent.
- EVT_MOUSE_*(func):
  See wxMouseEvent.
- EVT_PAINT(func):
  Process a `wxEVT_PAINT` event. See wxPaintEvent.
- EVT_POWER_*(func):
  The system power state changed. See wxPowerEvent.
- EVT_SCROLLWIN_*(func):
  Process scroll events. See wxScrollWinEvent.
- EVT_SET_CURSOR(func):
  Process a `wxEVT_SET_CURSOR` event. See wxSetCursorEvent.
- EVT_SIZE(func):
  Process a `wxEVT_SIZE` event. See wxSizeEvent.
- EVT_SYS_COLOUR_CHANGED(func):
  Process a `wxEVT_SYS_COLOUR_CHANGED` event. See wxSysColourChangedEvent.

  ##

Library: wxCore

<>< =''>:</>&;&;< =''>\ </></>

See also
  Events and Event Handling, Window Sizing Overview

## Classes
class | ChildrenRepositioningGuard
| Helper for ensuring EndRepositioningChildren() is called correctly. More...

## Public Member Functions
| wxWindow ()
| Default constructor. More...
| wxWindow (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Constructs a window, which can be a child of a frame, dialog or any other non-control window. More...
virtual | ~wxWindow ()
| Destructor. More...
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
Focus functions
See also the static function FindFocus().
virtual bool | AcceptsFocus () const
| This method may be overridden in the derived classes to return false to indicate that this control doesn't accept input at all (i.e. behaves like e.g. wxStaticText) and so doesn't need focus. More...
virtual bool | AcceptsFocusFromKeyboard () const
| This method may be overridden in the derived classes to return false to indicate that while this control can, in principle, have focus if the user clicks it with the mouse, it shouldn't be included in the TAB traversal chain when using the keyboard. More...
virtual bool | AcceptsFocusRecursively () const
| Overridden to indicate whether this window or one of its children accepts focus. More...
bool | IsFocusable () const
| Can this window itself have focus? More...
bool | CanAcceptFocus () const
| Can this window have focus right now? More...
bool | CanAcceptFocusFromKeyboard () const
| Can this window be assigned focus from keyboard right now? More...
virtual bool | HasFocus () const
| Returns true if the window (or in case of composite controls, its main child window) has focus. More...
virtual void | SetCanFocus (bool canFocus)
| This method is only implemented by ports which have support for native TAB traversal (such as GTK+ 2.0). More...
virtual void | SetFocus ()
| This sets the window to receive keyboard input. More...
virtual void | SetFocusFromKbd ()
| This function is called by wxWidgets keyboard navigation code when the user gives the focus to this window from keyboard (e.g. More...
Child management functions
virtual void | AddChild (wxWindow *child)
| Adds a child window. More...
bool | DestroyChildren ()
| Destroys all children of a window. More...
wxWindow * | FindWindow (long id) const
| Find a child of this window, by id. More...
wxWindow * | FindWindow (const wxString &name) const
| Find a child of this window, by name. More...
wxWindowList & | GetChildren ()
| Returns a reference to the list of the window's children. More...
const wxWindowList & | GetChildren () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual void | RemoveChild (wxWindow *child)
| Removes a child window. More...
Sibling and parent management functions
wxWindow * | GetGrandParent () const
| Returns the grandparent of a window, or NULL if there isn't one. More...
wxWindow * | GetNextSibling () const
| Returns the next window after this one among the parent's children or NULL if this window is the last child. More...
wxWindow * | GetParent () const
| Returns the parent of the window, or NULL if there is no parent. More...
wxWindow * | GetPrevSibling () const
| Returns the previous window before this one among the parent's children or `` NULL if this window is the first child. More...
bool | IsDescendant (wxWindowBase *win) const
| Check if the specified window is a descendant of this one. More...
virtual bool | Reparent (wxWindow *newParent)
| Reparents the window, i.e. the window will be removed from its current parent window (e.g. More...
Scrolling and scrollbars functions
Note that these methods don't work with native controls which don't use wxWidgets scrolling framework (i.e. don't derive from wxScrolledWindow).
virtual void | AlwaysShowScrollbars (bool hflag=true, bool vflag=true)
| Call this function to force one or both scrollbars to be always shown, even if the window is big enough to show its entire contents without scrolling. More...
virtual int | GetScrollPos (int orientation) const
| Returns the built-in scrollbar position. More...
virtual int | GetScrollRange (int orientation) const
| Returns the built-in scrollbar range. More...
virtual int | GetScrollThumb (int orientation) const
| Returns the built-in scrollbar thumb size. More...
bool | CanScroll (int orient) const
| Returns true if this window can have a scroll bar in this orientation. More...
bool | HasScrollbar (int orient) const
| Returns true if this window currently has a scroll bar for this orientation. More...
virtual bool | IsScrollbarAlwaysShown (int orient) const
| Return whether a scrollbar is always shown. More...
virtual bool | ScrollLines (int lines)
| Scrolls the window by the given number of lines down (if lines is positive) or up. More...
virtual bool | ScrollPages (int pages)
| Scrolls the window by the given number of pages down (if pages is positive) or up. More...
virtual void | ScrollWindow (int dx, int dy, const wxRect *rect=NULL)
| Physically scrolls the pixels in the window and move child windows accordingly. More...
bool | LineUp ()
| Same as ScrollLines (-1). More...
bool | LineDown ()
| Same as ScrollLines (1). More...
bool | PageUp ()
| Same as ScrollPages (-1). More...
bool | PageDown ()
| Same as ScrollPages (1). More...
virtual void | SetScrollPos (int orientation, int pos, bool refresh=true)
| Sets the position of one of the built-in scrollbars. More...
virtual void | SetScrollbar (int orientation, int position, int thumbSize, int range, bool refresh=true)
| Sets the scrollbar properties of a built-in scrollbar. More...
Sizing functions
See also the protected functions DoGetBestSize() and DoGetBestClientSize().
bool | BeginRepositioningChildren ()
| Prepare for changing positions of multiple child windows. More...
void | EndRepositioningChildren ()
| Fix child window positions after setting all of them at once. More...
void | CacheBestSize (const wxSize &size) const
| Sets the cached best size value. More...
virtual wxSize | ClientToWindowSize (const wxSize &size) const
| Converts client area size size to corresponding window size. More...
virtual wxSize | WindowToClientSize (const wxSize &size) const
| Converts window size size to corresponding client area size In other words, the returned value is what would GetClientSize() return if this window had given window size. More...
virtual void | Fit ()
| Sizes the window so that it fits around its subwindows. More...
virtual void | FitInside ()
| Similar to Fit(), but sizes the interior (virtual) size of a window. More...
wxSize | GetBestSize () const
| This functions returns the best acceptable minimal size for the window. More...
int | GetBestHeight (int width) const
| Returns the best height needed by this window if it had the given width. More...
int | GetBestWidth (int height) const
| Returns the best width needed by this window if it had the given height. More...
void | GetClientSize (int *width, int *height) const
| Returns the size of the window 'client area' in pixels. More...
wxSize | GetClientSize () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual wxSize | GetEffectiveMinSize () const
| Merges the window's best size into the min size and returns the result. More...
virtual wxSize | GetMaxClientSize () const
| Returns the maximum size of window's client area. More...
virtual wxSize | GetMaxSize () const
| Returns the maximum size of the window. More...
virtual wxSize | GetMinClientSize () const
| Returns the minimum size of window's client area, an indication to the sizer layout mechanism that this is the minimum required size of its client area. More...
virtual wxSize | GetMinSize () const
| Returns the minimum size of the window, an indication to the sizer layout mechanism that this is the minimum required size. More...
int | GetMinWidth () const
| Returns the horizontal component of window minimal size. More...
int | GetMinHeight () const
| Returns the vertical component of window minimal size. More...
int | GetMaxWidth () const
| Returns the horizontal component of window maximal size. More...
int | GetMaxHeight () const
| Returns the vertical component of window maximal size. More...
void | GetSize (int *width, int *height) const
| Returns the size of the entire window in pixels, including title bar, border, scrollbars, etc. More...
wxSize | GetSize () const
| See the GetSize(int*,int*) overload for more info. More...
wxSize | GetVirtualSize () const
| This gets the virtual size of the window in pixels. More...
void | GetVirtualSize (int *width, int *height) const
| Like the other GetVirtualSize() overload but uses pointers instead. More...
virtual wxSize | GetBestVirtualSize () const
| Return the largest of ClientSize and BestSize (as determined by a sizer, interior children, or other means) More...
virtual double | GetContentScaleFactor () const
| Returns the magnification of the backing store of this window, eg 2.0 for a window on a retina screen. More...
virtual wxSize | GetWindowBorderSize () const
| Returns the size of the left/right and top/bottom borders of this window in x and y components of the result respectively. More...
virtual bool | InformFirstDirection (int direction, int size, int availableOtherDir)
| wxSizer and friends use this to give a chance to a component to recalc its min size once one of the final size components is known. More...
void | InvalidateBestSize ()
| Resets the cached best size value so it will be recalculated the next time it is needed. More...
void | PostSizeEvent ()
| Posts a size event to the window. More...
void | PostSizeEventToParent ()
| Posts a size event to the parent of this window. More...
virtual void | SendSizeEvent (int flags=0)
| This function sends a dummy size event to the window allowing it to re-layout its children positions. More...
void | SendSizeEventToParent (int flags=0)
| Safe wrapper for GetParent()->SendSizeEvent(). More...
void | SetClientSize (int width, int height)
| This sets the size of the window client area in pixels. More...
void | SetClientSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetClientSize (const wxRect &rect)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetContainingSizer (wxSizer *sizer)
| This normally does not need to be called by user code. More...
void | SetInitialSize (const wxSize &size=wxDefaultSize)
| A smart SetSize that will fill in default size components with the window's best size values. More...
virtual void | SetMaxClientSize (const wxSize &size)
| Sets the maximum client size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size of its client area. More...
virtual void | SetMaxSize (const wxSize &size)
| Sets the maximum size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size. More...
virtual void | SetMinClientSize (const wxSize &size)
| Sets the minimum client size of the window, to indicate to the sizer layout mechanism that this is the minimum required size of window's client area. More...
virtual void | SetMinSize (const wxSize &size)
| Sets the minimum size of the window, to indicate to the sizer layout mechanism that this is the minimum required size. More...
void | SetSize (int x, int y, int width, int height, int sizeFlags=wxSIZE_AUTO)
| Sets the size of the window in pixels. More...
void | SetSize (const wxRect &rect)
| Sets the size of the window in pixels. More...
void | SetSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetSize (int width, int height)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual void | SetSizeHints (const wxSize &minSize, const wxSize &maxSize=wxDefaultSize, const wxSize &incSize=wxDefaultSize)
| Use of this function for windows which are not toplevel windows (such as wxDialog or wxFrame) is discouraged. More...
virtual void | SetSizeHints (int minW, int minH, int maxW=-1, int maxH=-1, int incW=-1, int incH=-1)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetVirtualSize (int width, int height)
| Sets the virtual size of the window in pixels. More...
void | SetVirtualSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
Positioning functions
void | Center (int dir=wxBOTH)
| A synonym for Centre(). More...
void | CenterOnParent (int dir=wxBOTH)
| A synonym for CentreOnParent(). More...
void | Centre (int direction=wxBOTH)
| Centres the window. More...
void | CentreOnParent (int direction=wxBOTH)
| Centres the window on its parent. More...
void | GetPosition (int *x, int *y) const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows. More...
wxPoint | GetPosition () const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows. More...
wxRect | GetRect () const
| Returns the position and size of the window as a wxRect object. More...
void | GetScreenPosition (int *x, int *y) const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one. More...
wxPoint | GetScreenPosition () const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one. More...
wxRect | GetScreenRect () const
| Returns the position and size of the window on the screen as a wxRect object. More...
virtual wxPoint | GetClientAreaOrigin () const
| Get the origin of the client area of the window relative to the window top left corner (the client area may be shifted because of the borders, scrollbars, other decorations...) More...
wxRect | GetClientRect () const
| Get the client rectangle in window (i.e. client) coordinates. More...
void | Move (int x, int y, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position. More...
void | Move (const wxPoint &pt, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position. More...
void | SetPosition (const wxPoint &pt)
| Moves the window to the specified position. More...
Coordinate conversion functions
void | ClientToScreen (int *x, int *y) const
| Converts to screen coordinates from coordinates relative to this window. More...
wxPoint | ClientToScreen (const wxPoint &pt) const
| Converts to screen coordinates from coordinates relative to this window. More...
wxPoint | ConvertDialogToPixels (const wxPoint &pt) const
| Converts a point or size from dialog units to pixels. More...
wxSize | ConvertDialogToPixels (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
wxPoint | ConvertPixelsToDialog (const wxPoint &pt) const
| Converts a point or size from pixels to dialog units. More...
wxSize | ConvertPixelsToDialog (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | ScreenToClient (int *x, int *y) const
| Converts from screen to client window coordinates. More...
wxPoint | ScreenToClient (const wxPoint &pt) const
| Converts from screen to client window coordinates. More...
Drawing-related functions
virtual void | ClearBackground ()
| Clears the window by filling it with the current background colour. More...
void | Freeze ()
| Freezes the window or, in other words, prevents any updates from taking place on screen, the window is not redrawn at all. More...
void | Thaw ()
| Re-enables window updating after a previous call to Freeze(). More...
bool | IsFrozen () const
| Returns true if the window is currently frozen by a call to Freeze(). More...
wxColour | GetBackgroundColour () const
| Returns the background colour of the window. More...
virtual wxBackgroundStyle | GetBackgroundStyle () const
| Returns the background style of the window. More...
virtual int | GetCharHeight () const
| Returns the character height for this window. More...
virtual int | GetCharWidth () const
| Returns the average character width for this window. More...
virtual wxVisualAttributes | GetDefaultAttributes () const
| Currently this is the same as calling wxWindow::GetClassDefaultAttributes(wxWindow::GetWindowVariant()). More...
wxFont | GetFont () const
| Returns the font for this window. More...
wxColour | GetForegroundColour () const
| Returns the foreground colour of the window. More...
void | GetTextExtent (const wxString &string, int *w, int *h, int *descent=NULL, int *externalLeading=NULL, const wxFont *font=NULL) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font. More...
wxSize | GetTextExtent (const wxString &string) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font. More...
const wxRegion & | GetUpdateRegion () const
| Returns the region specifying which parts of the window have been damaged. More...
wxRect | GetUpdateClientRect () const
| Get the update rectangle bounding box in client coords. More...
virtual bool | HasTransparentBackground ()
| Returns true if this window background is transparent (as, for example, for wxStaticText) and should show the parent window background. More...
virtual void | Refresh (bool eraseBackground=true, const wxRect *rect=NULL)
| Causes this window, and all of its children recursively (except under wxGTK1 where this is not implemented), to be repainted. More...
void | RefreshRect (const wxRect &rect, bool eraseBackground=true)
| Redraws the contents of the given rectangle: only the area inside it will be repainted. More...
virtual void | Update ()
| Calling this method immediately repaints the invalidated area of the window and all of its children recursively (this normally only happens when the flow of control returns to the event loop). More...
virtual bool | SetBackgroundColour (const wxColour &colour)
| Sets the background colour of the window. More...
virtual bool | SetBackgroundStyle (wxBackgroundStyle style)
| Sets the background style of the window. More...
virtual bool | IsTransparentBackgroundSupported (wxString *reason=NULL) const
| Checks whether using transparent background might work. More...
virtual bool | SetFont (const wxFont &font)
| Sets the font for this window. More...
virtual bool | SetForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window. More...
void | SetOwnBackgroundColour (const wxColour &colour)
| Sets the background colour of the window but prevents it from being inherited by the children of this window. More...
bool | InheritsBackgroundColour () const
| Return true if this window inherits the background colour from its parent. More...
bool | UseBgCol () const
| Return true if a background colour has been set for this window. More...
void | SetOwnFont (const wxFont &font)
| Sets the font of the window but prevents it from being inherited by the children of this window. More...
void | SetOwnForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window but prevents it from being inherited by the children of this window. More...
void | SetPalette (const wxPalette &pal)
virtual bool | ShouldInheritColours () const
| Return true from here to allow the colours of this window to be changed by InheritAttributes(). More...
virtual void | SetThemeEnabled (bool enable)
| This function tells a window if it should use the system's "theme" code to draw the windows' background instead of its own background drawing code. More...
virtual bool | GetThemeEnabled () const
| Clears the window by filling it with the current background colour. More...
virtual bool | CanSetTransparent ()
| Returns true if the system supports transparent windows and calling SetTransparent() may succeed. More...
virtual bool | SetTransparent (wxByte alpha)
| Set the transparency of the window. More...
Event-handling functions
wxWindow allows you to build a (sort of) stack of event handlers which can be used to override the window's own event handling.
wxEvtHandler * | GetEventHandler () const
| Returns the event handler for this window. More...
bool | HandleAsNavigationKey (const wxKeyEvent &event)
| This function will generate the appropriate call to Navigate() if the key event is one normally used for keyboard navigation and return true in this case. More...
bool | HandleWindowEvent (wxEvent &event) const
| Shorthand for: More...
bool | ProcessWindowEvent (wxEvent &event)
| Convenient wrapper for ProcessEvent(). More...
bool | ProcessWindowEventLocally (wxEvent &event)
| Wrapper for wxEvtHandler::ProcessEventLocally(). More...
wxEvtHandler * | PopEventHandler (bool deleteHandler=false)
| Removes and returns the top-most event handler on the event handler stack. More...
void | PushEventHandler (wxEvtHandler *handler)
| Pushes this event handler onto the event stack for the window. More...
bool | RemoveEventHandler (wxEvtHandler *handler)
| Find the given handler in the windows event handler stack and removes (but does not delete) it from the stack. More...
void | SetEventHandler (wxEvtHandler *handler)
| Sets the event handler for this window. More...
virtual void | SetNextHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called. More...
virtual void | SetPreviousHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called. More...
Window styles functions
long | GetExtraStyle () const
| Returns the extra style bits for the window. More...
virtual long | GetWindowStyleFlag () const
| Gets the window style that was passed to the constructor or Create() method. More...
long | GetWindowStyle () const
| See GetWindowStyleFlag() for more info. More...
bool | HasExtraStyle (int exFlag) const
| Returns true if the window has the given exFlag bit set in its extra styles. More...
bool | HasFlag (int flag) const
| Returns true if the window has the given flag bit set. More...
virtual void | SetExtraStyle (long exStyle)
| Sets the extra style bits for the window. More...
virtual void | SetWindowStyleFlag (long style)
| Sets the style of the window. More...
void | SetWindowStyle (long style)
| See SetWindowStyleFlag() for more info. More...
bool | ToggleWindowStyle (int flag)
| Turns the given flag on if it's currently turned off and vice versa. More...
Tab order functions
void | MoveAfterInTabOrder (wxWindow *win)
| Moves this window in the tab navigation order after the specified win. More...
void | MoveBeforeInTabOrder (wxWindow *win)
| Same as MoveAfterInTabOrder() except that it inserts this window just before win instead of putting it right after it. More...
bool | Navigate (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action starting from this window. More...
bool | NavigateIn (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action inside this window. More...
Z order functions
virtual void | Lower ()
| Lowers the window to the bottom of the window hierarchy (Z-order). More...
virtual void | Raise ()
| Raises the window to the top of the window hierarchy (Z-order). More...
Window status functions
bool | Hide ()
| Equivalent to calling wxWindow::Show(false). More...
virtual bool | HideWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function hides a window, like Hide(), but using a special visual effect if possible. More...
bool | IsEnabled () const
| Returns true if the window is enabled, i.e. if it accepts user input, false otherwise. More...
bool | IsExposed (int x, int y) const
| Returns true if the given point or rectangle area has been exposed since the last repaint. More...
bool | IsExposed (wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
bool | IsExposed (int x, int y, int w, int h) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
bool | IsExposed (wxRect &rect) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual bool | IsShown () const
| Returns true if the window is shown, false if it has been hidden. More...
virtual bool | IsShownOnScreen () const
| Returns true if the window is physically visible on the screen, i.e. it is shown and all its parents up to the toplevel window are shown as well. More...
bool | Disable ()
| Disables the window. More...
virtual bool | Enable (bool enable=true)
| Enable or disable the window for user input. More...
virtual bool | Show (bool show=true)
| Shows or hides the window. More...
virtual bool | ShowWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function shows a window, like Show(), but using a special visual effect if possible. More...
Context-sensitive help functions
wxString | GetHelpText () const
| Gets the help text to be used as context-sensitive help for this window. More...
void | SetHelpText (const wxString &helpText)
| Sets the help text to be used as context-sensitive help for this window. More...
virtual wxString | GetHelpTextAtPoint (const wxPoint &point, wxHelpEvent::Origin origin) const
| Gets the help text to be used as context-sensitive help for this window. More...
wxToolTip * | GetToolTip () const
| Get the associated tooltip or NULL if none. More...
wxString | GetToolTipText () const
| Get the text of the associated tooltip or empty string if none. More...
void | SetToolTip (const wxString &tipString)
| Attach a tooltip to the window. More...
void | SetToolTip (wxToolTip *tip)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | UnsetToolTip ()
| Unset any existing tooltip. More...
Popup/context menu functions
int | GetPopupMenuSelectionFromUser (wxMenu &menu, const wxPoint &pos=wxDefaultPosition)
| This function shows a popup menu at the given position in this window and returns the selected id. More...
int | GetPopupMenuSelectionFromUser (wxMenu &menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
bool | PopupMenu (wxMenu *menu, const wxPoint &pos=wxDefaultPosition)
| Pops up the given menu at the specified coordinates, relative to this window, and returns control when the user has dismissed the menu. More...
bool | PopupMenu (wxMenu *menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual wxValidator * | GetValidator ()
| Validator functions. More...
virtual void | SetValidator (const wxValidator &validator)
| Deletes the current validator (if any) and sets the window validator, having called wxValidator::Clone to create a new validator of this type. More...
virtual bool | TransferDataFromWindow ()
| Transfers values from child controls to data areas specified by their validators. More...
virtual bool | TransferDataToWindow ()
| Transfers values to child controls from data areas specified by their validators. More...
virtual bool | Validate ()
| Validates the current values of the child controls using their validators. More...
wxWindow properties functions
wxWindowID | GetId () const
| Returns the identifier of the window. More...
virtual wxString | GetLabel () const
| Generic way of getting a label from any window, for identification purposes. More...
virtual wxLayoutDirection | GetLayoutDirection () const
| Returns the layout direction for this window, Note that `wxLayout_Default` is returned if layout direction is not supported. More...
virtual wxCoord | AdjustForLayoutDirection (wxCoord x, wxCoord width, wxCoord widthTotal) const
| Mirror coordinates for RTL layout if this window uses it and if the mirroring is not done automatically like Win32. More...
virtual wxString | GetName () const
| Returns the window's name. More...
wxWindowVariant | GetWindowVariant () const
| Returns the value previously passed to SetWindowVariant(). More...
void | SetId (wxWindowID winid)
| Sets the identifier of the window. More...
virtual void | SetLabel (const wxString &label)
| Sets the window's label. More...
virtual void | SetLayoutDirection (wxLayoutDirection dir)
| Sets the layout direction for this window. More...
virtual void | SetName (const wxString &name)
| Sets the window's name. More...
void | SetWindowVariant (wxWindowVariant variant)
| Chooses a different variant of the window display to use. More...
wxAcceleratorTable * | GetAcceleratorTable ()
| Gets the accelerator table for this window. More...
wxAccessible * | GetAccessible ()
| Returns the accessible object for this window, if any. More...
virtual void | SetAcceleratorTable (const wxAcceleratorTable &accel)
| Sets the accelerator table for this window. More...
void | SetAccessible (wxAccessible *accessible)
| Sets the accessible for this window. More...
Window deletion functions
bool | Close (bool force=false)
| This function simply generates a wxCloseEvent whose handler usually tries to close the window. More...
virtual bool | Destroy ()
| Destroys the window safely. More...
bool | IsBeingDeleted () const
| Returns true if this window is in process of being destroyed. More...
Drag and drop functions
virtual wxDropTarget * | GetDropTarget () const
| Returns the associated drop target, which may be NULL. More...
virtual void | SetDropTarget (wxDropTarget *target)
| Associates a drop target with this window. More...
virtual void | DragAcceptFiles (bool accept)
| Enables or disables eligibility for drop file events (OnDropFiles). More...
Constraints, sizers and window layout functions
wxSizer * | GetContainingSizer () const
| Returns the sizer of which this window is a member, if any, otherwise NULL. More...
wxSizer * | GetSizer () const
| Returns the sizer associated with the window by a previous call to SetSizer(), or NULL. More...
void | SetSizer (wxSizer *sizer, bool deleteOld=true)
| Sets the window to have the given layout sizer. More...
void | SetSizerAndFit (wxSizer *sizer, bool deleteOld=true)
| This method calls SetSizer() and then wxSizer::SetSizeHints which sets the initial window size to the size needed to accommodate all sizer elements and sets the size hints which, if this window is a top level one, prevent the user from resizing it to be less than this minimal size. More...
wxLayoutConstraints * | GetConstraints () const
| Returns a pointer to the window's layout constraints, or NULL if there are none. More...
void | SetConstraints (wxLayoutConstraints *constraints)
| Sets the window to have the given layout constraints. More...
virtual bool | Layout ()
| Invokes the constraint-based layout algorithm or the sizer-based algorithm for this window. More...
void | SetAutoLayout (bool autoLayout)
| Determines whether the Layout() function will be called automatically when the window is resized. More...
bool | GetAutoLayout () const
| Returns the sizer of which this window is a member, if any, otherwise NULL. More...
Mouse functions
void | CaptureMouse ()
| Directs all mouse input to this window. More...
wxCaret * | GetCaret () const
| Returns the caret() associated with the window. More...
const wxCursor & | GetCursor () const
| Return the cursor associated with this window. More...
virtual bool | HasCapture () const
| Returns true if this window has the current mouse capture. More...
void | ReleaseMouse ()
| Releases mouse input captured with CaptureMouse(). More...
void | SetCaret (wxCaret *caret)
| Sets the caret() associated with the window. More...
virtual bool | SetCursor (const wxCursor &cursor)
| Sets the window's cursor. More...
virtual void | WarpPointer (int x, int y)
| Moves the pointer to the given position on the window. More...
Miscellaneous functions
wxHitTest | HitTest (wxCoord x, wxCoord y) const
| Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable. More...
wxHitTest | HitTest (const wxPoint &pt) const
| Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable. More...
wxBorder | GetBorder (long flags) const
| Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable. More...
wxBorder | GetBorder () const
| Get border for the flags of this window. More...
virtual void | DoUpdateWindowUI (wxUpdateUIEvent &event)
| Does the window-specific updating after processing the update event. More...
virtual WXWidget | GetHandle () const
| Returns the platform-specific handle of the physical window. More...
virtual bool | HasMultiplePages () const
| This method should be overridden to return true if this window has multiple pages. More...
virtual void | InheritAttributes ()
| This function is (or should be, in case of custom controls) called during window creation to intelligently set up the window visual attributes, that is the font and the foreground and background colours. More...
virtual void | InitDialog ()
| Sends an `wxEVT_INIT_DIALOG` event, whose handler usually transfers data to the dialog via validators. More...
virtual bool | IsDoubleBuffered () const
| Returns true if the window contents is double-buffered by the system, i.e. if any drawing done on the window is really done on a temporary backing surface and transferred to the screen all at once later. More...
void | SetDoubleBuffered (bool on)
| Turn on or off double buffering of the window if the system supports it. More...
virtual bool | IsRetained () const
| Returns true if the window is retained, false otherwise. More...
bool | IsThisEnabled () const
| Returns true if this window is intrinsically enabled, false otherwise, i.e. if Enable() Enable(false) had been called. More...
virtual bool | IsTopLevel () const
| Returns true if the given window is a top-level one. More...
virtual void | OnInternalIdle ()
| This virtual function is normally only used internally, but sometimes an application may need it to implement functionality that should not be disabled by an application defining an OnIdle handler in a derived class. More...
virtual bool | SendIdleEvents (wxIdleEvent &event)
| Send idle event to window and all subwindows. More...
virtual bool | RegisterHotKey (int hotkeyId, int modifiers, int virtualKeyCode)
| Registers a system wide hotkey. More...
virtual bool | UnregisterHotKey (int hotkeyId)
| Unregisters a system wide hotkey. More...
virtual void | UpdateWindowUI (long flags=wxUPDATE_UI_NONE)
| This function sends one or more wxUpdateUIEvent to the window. More...
Public Member Functions inherited from wxEvtHandler
| wxEvtHandler ()
| Constructor. More...
virtual | ~wxEvtHandler ()
| Destructor. More...
template<typename T , typename T1 , ... >
void | CallAfter (void(T::*method)(T1,...), T1 x1,...)
| Asynchronously call the given method. More...
template<typename T >
void | CallAfter (const T &functor)
| Asynchronously call the given functor. More...
bool | ProcessEventLocally (wxEvent &event)
| Try to process the event in this handler and all those chained to it. More...
bool | SafelyProcessEvent (wxEvent &event)
| Processes an event by calling ProcessEvent() and handles any exceptions that occur in the process. More...
void | ProcessPendingEvents ()
| Processes the pending events previously queued using QueueEvent() or AddPendingEvent(); you must call this function only if you are sure there are pending events for this handler, otherwise a `wxCHECK` will fail. More...
void | DeletePendingEvents ()
| Deletes all events queued on this event handler using QueueEvent() or AddPendingEvent(). More...
virtual bool | SearchEventTable (wxEventTable &table, wxEvent &event)
| Searches the event table, executing an event handler function if an appropriate one is found. More...
void | Connect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Connects the given function dynamically with the event handler, id and event type. More...
void | Connect (int id, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
void | Connect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
bool | Disconnect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Disconnects the given function dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed. More...
bool | Disconnect (int id=wxID_ANY, wxEventType eventType=wxEVT_NULL, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
bool | Disconnect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
template<typename EventTag , typename Functor >
void | Bind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Binds the given function, functor or method dynamically with the event. More...
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
void | Bind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Bind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info. More...
template<typename EventTag , typename Functor >
bool | Unbind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Unbinds the given function, functor or method dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed. More...
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
bool | Unbind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Unbind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info. More...
void * | GetClientData () const
| Returns user-supplied client data. More...
wxClientData * | GetClientObject () const
| Returns a pointer to the user-supplied client data object. More...
void | SetClientData (void *data)
| Sets user-supplied client data. More...
void | SetClientObject (wxClientData *data)
| Set the client data object. More...
bool | GetEvtHandlerEnabled () const
| Returns true if the event handler is enabled, false otherwise. More...
wxEvtHandler * | GetNextHandler () const
| Returns the pointer to the next handler in the chain. More...
wxEvtHandler * | GetPreviousHandler () const
| Returns the pointer to the previous handler in the chain. More...
void | SetEvtHandlerEnabled (bool enabled)
| Enables or disables the event handler. More...
void | Unlink ()
| Unlinks this event handler from the chain it's part of (if any); then links the "previous" event handler to the "next" one (so that the chain won't be interrupted). More...
bool | IsUnlinked () const
| Returns true if the next and the previous handler pointers of this event handler instance are NULL. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...

## Static Public Member Functions
Miscellaneous static functions
static wxVisualAttributes | GetClassDefaultAttributes (wxWindowVariant variant=wxWINDOW_VARIANT_NORMAL)
| Returns the default font and colours which are used by the control. More...
static wxWindow * | FindFocus ()
| Finds the window or control which currently has the keyboard focus. More...
static wxWindow * | FindWindowById (long id, const wxWindow *parent=0)
| Find the first window with the given id. More...
static wxWindow * | FindWindowByLabel (const wxString &label, const wxWindow *parent=0)
| Find a window by its label. More...
static wxWindow * | FindWindowByName (const wxString &name, const wxWindow *parent=0)
| Find a window by its name (as given in a window constructor or Create() function call). More...
static wxWindow * | GetCapture ()
| Returns the currently captured window. More...
static wxWindowID | NewControlId (int count=1)
| Create a new ID or range of IDs that are not currently in use. More...
static void | UnreserveControlId (wxWindowID id, int count=1)
| Unreserve an ID or range of IDs that was reserved by NewControlId(). More...
Static Public Member Functions inherited from wxEvtHandler
static void | AddFilter (wxEventFilter *filter)
| Add an event filter whose FilterEvent() method will be called for each and every event processed by wxWidgets. More...
static void | RemoveFilter (wxEventFilter *filter)
| Remove a filter previously installed with AddFilter(). More...

## Protected Member Functions
virtual void | DoCentre (int direction)
| Centres the window. More...
virtual wxSize | DoGetBestSize () const
| Implementation of GetBestSize() that can be overridden. More...
virtual wxSize | DoGetBestClientSize () const
| Override this method to return the best size for a custom control. More...
virtual int | DoGetBestClientHeight (int width) const
| Override this method to implement height-for-width best size calculation. More...
virtual int | DoGetBestClientWidth (int height) const
| Override this method to implement width-for-height best size calculation. More...
virtual void | SetInitialBestSize (const wxSize &size)
| Sets the initial window size if none is given (i.e. at least one of the components of the size passed to ctor/Create() is wxDefaultCoord). More...
void | SendDestroyEvent ()
| Generate wxWindowDestroyEvent for this window. More...
virtual bool | ProcessEvent (wxEvent &event)
| This function is public in wxEvtHandler but protected in wxWindow because for wxWindows you should always call ProcessEvent() on the pointer returned by GetEventHandler() and not on the wxWindow object itself. More...
bool | SafelyProcessEvent (wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. More...
virtual void | QueueEvent (wxEvent *event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. More...
virtual void | AddPendingEvent (const wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. More...
void | ProcessPendingEvents ()
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. More...
bool | ProcessThreadEvent (const wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. More...
Protected Member Functions inherited from wxEvtHandler
virtual bool | TryBefore (wxEvent &event)
| Method called by ProcessEvent() before examining this object event tables. More...
virtual bool | TryAfter (wxEvent &event)
| Method called by ProcessEvent() as last resort. More...
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...

## Additional Inherited Members
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxWindow() [1/2]

wxWindow::wxWindow | ( |  | ) |

Default constructor.

## ◆ wxWindow() [2/2]

wxWindow::wxWindow | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxString & | name = `wxPanelNameStr`
| ) |  |

Constructs a window, which can be a child of a frame, dialog or any other non-control window.

Parameters

  parent | Pointer to a parent window.
  id | Window identifier. If wxID_ANY, will automatically create an identifier.
  pos | Window position. wxDefaultPosition indicates that wxWidgets should generate a default position for the window. If using the wxWindow class directly, supply an actual position.
  size | Window size. wxDefaultSize indicates that wxWidgets should generate a default size for the window. If no suitable size can be found, the window will be sized to 20x20 pixels so that the window is visible but obviously not correctly sized.
  style | Window style. For generic window styles, please see wxWindow.
  name | Window name.

## ◆ ~wxWindow()

virtual wxWindow::~wxWindow | ( |  | ) |
| virtual

Destructor.

Deletes all sub-windows, then deletes itself. Instead of using the delete operator explicitly, you should normally use Destroy() so that wxWidgets can delete a window only when it is safe to do so, in idle time.

See also
  Window Deletion Overview, Destroy(), wxCloseEvent

## Member Function Documentation

## ◆ AcceptsFocus()

virtual bool wxWindow::AcceptsFocus | ( |  | ) | const
| virtual

This method may be overridden in the derived classes to return false to indicate that this control doesn't accept input at all (i.e. behaves like e.g. wxStaticText) and so doesn't need focus.

See also
  AcceptsFocusFromKeyboard()

Reimplemented in wxPanel.

## ◆ AcceptsFocusFromKeyboard()

virtual bool wxWindow::AcceptsFocusFromKeyboard | ( |  | ) | const
| virtual

This method may be overridden in the derived classes to return false to indicate that while this control can, in principle, have focus if the user clicks it with the mouse, it shouldn't be included in the TAB traversal chain when using the keyboard.

## ◆ AcceptsFocusRecursively()

virtual bool wxWindow::AcceptsFocusRecursively | ( |  | ) | const
| virtual

Overridden to indicate whether this window or one of its children accepts focus.

Usually it's the same as AcceptsFocus() but is overridden for container windows.

## ◆ AddChild()

virtual void wxWindow::AddChild | ( | wxWindow * | child | ) |
| virtual

Adds a child window.

This is called automatically by window creation functions so should not be required by the application programmer. Notice that this function is mostly internal to wxWidgets and shouldn't be called by the user code.

Parameters

  child | Child window to add.

## ◆ AddPendingEvent()

virtual void wxWindow::AddPendingEvent | ( | const wxEvent & | event | ) |
| protectedvirtual

See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.

Reimplemented from wxEvtHandler.

## ◆ AdjustForLayoutDirection()

virtual wxCoord wxWindow::AdjustForLayoutDirection | ( | wxCoord | x,
|  | wxCoord | width,
|  | wxCoord | widthTotal
| ) |  | const
| virtual

Mirror coordinates for RTL layout if this window uses it and if the mirroring is not done automatically like Win32.

## ◆ AlwaysShowScrollbars()

virtual void wxWindow::AlwaysShowScrollbars | ( | bool | hflag = `true`,
|  | bool | vflag = `true`
| ) |  |
| virtual

Call this function to force one or both scrollbars to be always shown, even if the window is big enough to show its entire contents without scrolling.

Since
  2.9.0

Parameters

  hflag | Whether the horizontal scroll bar should always be visible.
  vflag | Whether the vertical scroll bar should always be visible.

Remarks
  This function is currently only implemented under Mac/Carbon.

## ◆ BeginRepositioningChildren()

bool wxWindow::BeginRepositioningChildren | ( |  | ) |

Prepare for changing positions of multiple child windows.

This method should be called before changing positions of multiple child windows to reduce flicker and, in MSW case, even avoid display corruption in some cases. It is used internally by wxWidgets and called automatically when the window size changes but it can also be useful to call it from outside of the library if a repositioning involving multiple children is done without changing the window size.

If this method returns true, then EndRepositioningChildren() must be called after setting all children positions. Use ChildrenRepositioningGuard class to ensure that this requirement is satisfied.

Since
  2.9.5

## ◆ CacheBestSize()

void wxWindow::CacheBestSize | ( | const wxSize & | size | ) | const

Sets the cached best size value.

See also
  GetBestSize()

## ◆ CanAcceptFocus()

bool wxWindow::CanAcceptFocus | ( |  | ) | const

Can this window have focus right now?

If this method returns true, it means that calling SetFocus() will put focus either to this window or one of its children, if you need to know whether this window accepts focus itself, use IsFocusable()

## ◆ CanAcceptFocusFromKeyboard()

bool wxWindow::CanAcceptFocusFromKeyboard | ( |  | ) | const

Can this window be assigned focus from keyboard right now?

## ◆ CanScroll()

bool wxWindow::CanScroll | ( | int | orient | ) | const

Returns true if this window can have a scroll bar in this orientation.

Parameters

  orient | Orientation to check, either wxHORIZONTAL or wxVERTICAL.

Since
  2.9.1

## ◆ CanSetTransparent()

virtual bool wxWindow::CanSetTransparent | ( |  | ) |
| virtual

Returns true if the system supports transparent windows and calling SetTransparent() may succeed.

If this function returns false, transparent windows are definitely not supported by the current system.

Reimplemented in wxTopLevelWindow.

## ◆ CaptureMouse()

void wxWindow::CaptureMouse | ( |  | ) |

Directs all mouse input to this window.

Call ReleaseMouse() to release the capture.

Note that wxWidgets maintains the stack of windows having captured the mouse and when the mouse is released the capture returns to the window which had had captured it previously and it is only really released if there were no previous window. In particular, this means that you must release the mouse as many times as you capture it, unless the window receives the wxMouseCaptureLostEvent event.

Any application which captures the mouse in the beginning of some operation must handle wxMouseCaptureLostEvent and cancel this operation when it receives the event. The event handler must not recapture mouse.

See also
  ReleaseMouse(), wxMouseCaptureLostEvent

## ◆ Center()

void wxWindow::Center | ( | int | dir = `wxBOTH` | ) |

A synonym for Centre().

## ◆ CenterOnParent()

void wxWindow::CenterOnParent | ( | int | dir = `wxBOTH` | ) |

A synonym for CentreOnParent().

## ◆ Centre()

void wxWindow::Centre | ( | int | direction = `wxBOTH` | ) |

Centres the window.

Parameters

  direction | Specifies the direction for the centring. May be wxHORIZONTAL, wxVERTICAL or wxBOTH. It may also include the wxCENTRE_ON_SCREEN flag if you want to centre the window on the entire screen and not on its parent window.

Remarks
  If the window is a top level one (i.e. doesn't have a parent), it will be centred relative to the screen anyhow.

See also
  Center()

## ◆ CentreOnParent()

void wxWindow::CentreOnParent | ( | int | direction = `wxBOTH` | ) |

Centres the window on its parent.

This is a more readable synonym for Centre().

Parameters

  direction | Specifies the direction for the centring. May be wxHORIZONTAL, wxVERTICAL or wxBOTH.

Remarks
  This methods provides for a way to centre top level windows over their parents instead of the entire screen. If there is no parent or if the window is not a top level window, then behaviour is the same as Centre().

See also
  wxTopLevelWindow::CentreOnScreen

## ◆ ClearBackground()

virtual void wxWindow::ClearBackground | ( |  | ) |
| virtual

Clears the window by filling it with the current background colour.

Does not cause an erase background event to be generated.

Notice that this uses wxClientDC to draw on the window and the results of doing it while also drawing on wxPaintDC for this window are undefined. Hence this method shouldn't be used from EVT_PAINT handlers, just use wxDC::Clear() on the wxPaintDC you already use there instead.

## ◆ ClientToScreen() [1/2]

void wxWindow::ClientToScreen | ( | int * | x,
|  | int * | y
| ) |  | const

Converts to screen coordinates from coordinates relative to this window.

Parameters

  x | A pointer to a integer value for the x coordinate. Pass the client coordinate in, and a screen coordinate will be passed out.
  y | A pointer to a integer value for the y coordinate. Pass the client coordinate in, and a screen coordinate will be passed out.

wxPerl Note: In wxPerl this method returns a 2-element list instead of modifying its parameters.

## ◆ ClientToScreen() [2/2]

wxPoint wxWindow::ClientToScreen | ( | const wxPoint & | pt | ) | const

Converts to screen coordinates from coordinates relative to this window.

Parameters

  pt | The client position for the second form of the function.

## ◆ ClientToWindowSize()

virtual wxSize wxWindow::ClientToWindowSize | ( | const wxSize & | size | ) | const
| virtual

Converts client area size size to corresponding window size.

In other words, the returned value is what would GetSize() return if this window had client area of given size. Components with wxDefaultCoord value are left unchanged. Note that the conversion is not always exact, it assumes that non-client area doesn't change and so doesn't take into account things like menu bar (un)wrapping or (dis)appearance of the scrollbars.

Since
  2.8.8

See also
  WindowToClientSize()

## ◆ Close()

bool wxWindow::Close | ( | bool | force = `false` | ) |

This function simply generates a wxCloseEvent whose handler usually tries to close the window.

It doesn't close the window itself, however.

Parameters

  force | false if the window's close handler should be able to veto the destruction of this window, true if it cannot.

Returns
  true if the event was handled and not vetoed, false otherwise.

Remarks
  Close calls the close handler for the window, providing an opportunity for the window to choose whether to destroy the window. Usually it is only used with the top level windows (wxFrame and wxDialog classes) as the others are not supposed to have any special OnClose() logic. The close handler should check whether the window is being deleted forcibly, using wxCloseEvent::CanVeto, in which case it should destroy the window using wxWindow::Destroy. Note that calling Close does not guarantee that the window will be destroyed; but it provides a way to simulate a manual close of a window, which may or may not be implemented by destroying the window. The default implementation of wxDialog::OnCloseWindow does not necessarily delete the dialog, since it will simply simulate an wxID_CANCEL event which is handled by the appropriate button event handler and may do anything at all. To guarantee that the window will be destroyed, call wxWindow::Destroy instead

See also
  Window Deletion Overview, Destroy(), wxCloseEvent

## ◆ ConvertDialogToPixels() [1/2]

wxPoint wxWindow::ConvertDialogToPixels | ( | const wxPoint & | pt | ) | const

Converts a point or size from dialog units to pixels.

For the x dimension, the dialog units are multiplied by the average character width and then divided by 4. For the y dimension, the dialog units are multiplied by the average character height and then divided by 8.

Remarks
  Dialog units are used for maintaining a dialog's proportions even if the font changes. You can also use these functions programmatically. A convenience macro is defined:
  #define wxDLG_UNIT(parent, pt) parent->ConvertDialogToPixels(pt)

See also
  ConvertPixelsToDialog()

## ◆ ConvertDialogToPixels() [2/2]

wxSize wxWindow::ConvertDialogToPixels | ( | const wxSize & | sz | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ ConvertPixelsToDialog() [1/2]

wxPoint wxWindow::ConvertPixelsToDialog | ( | const wxPoint & | pt | ) | const

Converts a point or size from pixels to dialog units.

For the x dimension, the pixels are multiplied by 4 and then divided by the average character width. For the y dimension, the pixels are multiplied by 8 and then divided by the average character height.

Remarks
  Dialog units are used for maintaining a dialog's proportions even if the font changes.

See also
  ConvertDialogToPixels()

## ◆ ConvertPixelsToDialog() [2/2]

wxSize wxWindow::ConvertPixelsToDialog | ( | const wxSize & | sz | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ Create()

bool wxWindow::Create | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxString & | name = `wxPanelNameStr`
| ) |  |

## ◆ Destroy()

virtual bool wxWindow::Destroy | ( |  | ) |
| virtual

Destroys the window safely.

Use this function instead of the delete operator, since different window classes can be destroyed differently. Frames and dialogs are not destroyed immediately when this function is called – they are added to a list of windows to be deleted on idle time, when all the window's events have been processed. This prevents problems with events being sent to non-existent windows.

Returns
  true if the window has either been successfully deleted, or it has been added to the list of windows pending real deletion.

Reimplemented in wxAuiMDIChildFrame.

## ◆ DestroyChildren()

bool wxWindow::DestroyChildren | ( |  | ) |

Destroys all children of a window.

Called automatically by the destructor.

## ◆ Disable()

bool wxWindow::Disable | ( |  | ) |

Disables the window.

Same as Enable() Enable(false).

Returns
  Returns true if the window has been disabled, false if it had been already disabled before the call to this function.

## ◆ DoCentre()

virtual void wxWindow::DoCentre | ( | int | direction | ) |
| protectedvirtual

Centres the window.

Parameters

  direction | Specifies the direction for the centring. May be wxHORIZONTAL, wxVERTICAL or wxBOTH. It may also include the wxCENTRE_ON_SCREEN flag.

Remarks
  This function is not meant to be called directly by user code, but via Centre, Center, CentreOnParent, or CenterOnParent. This function can be overridden to fine-tune centring behaviour.

## ◆ DoGetBestClientHeight()

virtual int wxWindow::DoGetBestClientHeight | ( | int | width | ) | const
| protectedvirtual

Override this method to implement height-for-width best size calculation.

Return the height needed to fully display the control contents if its width is fixed to the given value. Custom classes implementing wrapping should override this method and return the height corresponding to the number of lines needed to lay out the control contents at this width.

Currently this method is not used by wxWidgets yet, however it is planned that it will be used by the new sizer classes implementing height-for-width layout strategy in the future.

Notice that implementing this method or even implementing both it and DoGetBestClientWidth() doesn't replace overriding DoGetBestClientSize(), i.e. you still need to implement the latter as well in order to provide the best size when neither width nor height are constrained.

By default returns wxDefaultCoord meaning that the vertical component of DoGetBestClientSize() return value should be used.

Since
  2.9.4

## ◆ DoGetBestClientSize()

virtual wxSize wxWindow::DoGetBestClientSize | ( |  | ) | const
| protectedvirtual

Override this method to return the best size for a custom control.

A typical implementation of this method should compute the minimal size needed to fully display the control contents taking into account the current font size.

The default implementation simply returns wxDefaultSize and GetBestSize() returns an arbitrary hardcoded size for the window, so you must override it when implementing a custom window class.

Notice that the best size returned by this function is cached internally, so if anything that results in the best size changing (e.g. change to the control contents) happens, you need to call InvalidateBestSize() to notify wxWidgets about it.

See also
  Window Sizing Overview

Since
  2.9.0

## ◆ DoGetBestClientWidth()

virtual int wxWindow::DoGetBestClientWidth | ( | int | height | ) | const
| protectedvirtual

Override this method to implement width-for-height best size calculation.

This method is exactly the same as DoGetBestClientHeight() except that it determines the width assuming the height is fixed instead of vice versa.

Since
  2.9.4

## ◆ DoGetBestSize()

virtual wxSize wxWindow::DoGetBestSize | ( |  | ) | const
| protectedvirtual

Implementation of GetBestSize() that can be overridden.

Notice that it is usually more convenient to override DoGetBestClientSize() rather than this method itself as you need to explicitly account for the window borders size if you do the latter.

The default implementation of this function is designed for use in container windows, such as wxPanel, and works something like this:

1. If the window has a sizer then it is used to calculate the best size.
2. Otherwise if the window has layout constraints then those are used to calculate the best size.
3. Otherwise if the window has children then the best size is set to be large enough to show all the children.
4. Otherwise if there are no children then the window's minimal size will be used as its best size.
5. Otherwise if there is no minimal size set, then the current size is used for the best size.

See also
  Window Sizing Overview

Reimplemented in wxRichTextCtrl.

## ◆ DoUpdateWindowUI()

virtual void wxWindow::DoUpdateWindowUI | ( | wxUpdateUIEvent & | event | ) |
| virtual

Does the window-specific updating after processing the update event.

This function is called by UpdateWindowUI() in order to check return values in the wxUpdateUIEvent and act appropriately. For example, to allow frame and dialog title updating, wxWidgets implements this function as follows:

// do the window-specific processing after processing the update event
void wxTopLevelWindowBase::DoUpdateWindowUI(wxUpdateUIEvent& event)
{
if ( event.GetSetEnabled() )
Enable(event.GetEnabled());
if ( event.GetSetText() )
{
if ( event.GetText() != GetTitle() )
SetTitle(event.GetText());
}
}

## ◆ DragAcceptFiles()

virtual void wxWindow::DragAcceptFiles | ( | bool | accept | ) |
| virtual

Enables or disables eligibility for drop file events (OnDropFiles).

Parameters

  accept | If true, the window is eligible for drop file events. If false, the window will not accept drop file events.

Remarks
  Windows only until version 2.8.9, available on all platforms since 2.8.10. Cannot be used together with SetDropTarget() on non-Windows platforms.

See also
  SetDropTarget()

## ◆ Enable()

virtual bool wxWindow::Enable | ( | bool | enable = `true` | ) |
| virtual

Enable or disable the window for user input.

Note that when a parent window is disabled, all of its children are disabled as well and they are reenabled again when the parent is.

Parameters

  enable | If true, enables the window for input. If false, disables the window.

Returns
  Returns true if the window has been enabled or disabled, false if nothing was done, i.e. if the window had already been in the specified state.

See also
  IsEnabled(), Disable(), wxRadioBox::Enable

## ◆ EndRepositioningChildren()

void wxWindow::EndRepositioningChildren | ( |  | ) |

Fix child window positions after setting all of them at once.

This method must be called if and only if the previous call to BeginRepositioningChildren() returned true.

Since
  2.9.5

## ◆ FindFocus()

static wxWindow* wxWindow::FindFocus | ( |  | ) |
| static

Finds the window or control which currently has the keyboard focus.

Remarks
  Note that this is a static function, so it can be called without needing a wxWindow pointer.

See also
  SetFocus(), HasFocus()

## ◆ FindWindow() [1/2]

wxWindow* wxWindow::FindWindow | ( | long | id | ) | const

Find a child of this window, by id.

May return this if it matches itself.

Notice that only real children, not top level windows using this window as parent, are searched by this function.

## ◆ FindWindow() [2/2]

wxWindow* wxWindow::FindWindow | ( | const wxString & | name | ) | const

Find a child of this window, by name.

May return this if it matches itself.

Notice that only real children, not top level windows using this window as parent, are searched by this function.

## ◆ FindWindowById()

static wxWindow* wxWindow::FindWindowById | ( | long | id,
|  | const wxWindow * | parent = `0`
| ) |  |
| static

Find the first window with the given id.

If parent is NULL, the search will start from all top-level frames and dialog boxes; if non-NULL, the search will be limited to the given window hierarchy. The search is recursive in both cases.

See also
  FindWindow()

Returns
  Window with the given id or NULL if not found.

## ◆ FindWindowByLabel()

static wxWindow* wxWindow::FindWindowByLabel | ( | const wxString & | label,
|  | const wxWindow * | parent = `0`
| ) |  |
| static

Find a window by its label.

Depending on the type of window, the label may be a window title or panel item label. If parent is NULL, the search will start from all top-level frames and dialog boxes; if non-NULL, the search will be limited to the given window hierarchy. The search is recursive in both cases.

See also
  FindWindow()

Returns
  Window with the given label or NULL if not found.

## ◆ FindWindowByName()

static wxWindow* wxWindow::FindWindowByName | ( | const wxString & | name,
|  | const wxWindow * | parent = `0`
| ) |  |
| static

Find a window by its name (as given in a window constructor or Create() function call).

If parent is NULL, the search will start from all top-level frames and dialog boxes; if non-NULL, the search will be limited to the given window hierarchy.

The search is recursive in both cases. If no window with such name is found, FindWindowByLabel() is called.

See also
  FindWindow()

Returns
  Window with the given name or NULL if not found.

## ◆ Fit()

virtual void wxWindow::Fit | ( |  | ) |
| virtual

Sizes the window so that it fits around its subwindows.

This function won't do anything if there are no subwindows and will only really work correctly if sizers are used for the subwindows layout.

Also, if the window has exactly one subwindow it is better (faster and the result is more precise as Fit() adds some margin to account for fuzziness of its calculations) to call:

window->SetClientSize(child->GetSize());

instead of calling Fit().

See also
  Window Sizing Overview

## ◆ FitInside()

virtual void wxWindow::FitInside | ( |  | ) |
| virtual

Similar to Fit(), but sizes the interior (virtual) size of a window.

Mainly useful with scrolled windows to reset scrollbars after sizing changes that do not trigger a size event, and/or scrolled windows without an interior sizer. This function similarly won't do anything if there are no subwindows.

## ◆ Freeze()

void wxWindow::Freeze | ( |  | ) |

Freezes the window or, in other words, prevents any updates from taking place on screen, the window is not redrawn at all.

Thaw() must be called to reenable window redrawing. Calls to these two functions may be nested but to ensure that the window is properly repainted again, you must thaw it exactly as many times as you froze it.

If the window has any children, they are recursively frozen too.

This method is useful for visual appearance optimization (for example, it is a good idea to use it before doing many large text insertions in a row into a wxTextCtrl under wxGTK) but is not implemented on all platforms nor for all controls so it is mostly just a hint to wxWidgets and not a mandatory directive.

See also
  wxWindowUpdateLocker, Thaw(), IsFrozen()

## ◆ GetAcceleratorTable()

wxAcceleratorTable* wxWindow::GetAcceleratorTable | ( |  | ) |

Gets the accelerator table for this window.

See wxAcceleratorTable.

## ◆ GetAccessible()

wxAccessible* wxWindow::GetAccessible | ( |  | ) |

Returns the accessible object for this window, if any.

See also wxAccessible.

## ◆ GetAutoLayout()

bool wxWindow::GetAutoLayout | ( |  | ) | const

Returns the sizer of which this window is a member, if any, otherwise NULL.

## ◆ GetBackgroundColour()

wxColour wxWindow::GetBackgroundColour | ( |  | ) | const

Returns the background colour of the window.

See also
  SetBackgroundColour(), SetForegroundColour(), GetForegroundColour()

## ◆ GetBackgroundStyle()

virtual wxBackgroundStyle wxWindow::GetBackgroundStyle | ( |  | ) | const
| virtual

Returns the background style of the window.

See also
  SetBackgroundColour(), GetForegroundColour(), SetBackgroundStyle(), SetTransparent()

## ◆ GetBestHeight()

int wxWindow::GetBestHeight | ( | int | width | ) | const

Returns the best height needed by this window if it had the given width.

See also
  DoGetBestClientHeight()

Since
  2.9.4

## ◆ GetBestSize()

wxSize wxWindow::GetBestSize | ( |  | ) | const

This functions returns the best acceptable minimal size for the window.

For example, for a static control, it will be the minimal size such that the control label is not truncated. For windows containing subwindows (typically wxPanel), the size returned by this function will be the same as the size the window would have had after calling Fit().

Override virtual DoGetBestSize() or, better, because it's usually more convenient, DoGetBestClientSize() when writing your own custom window class to change the value returned by this public non-virtual method.

Notice that the best size respects the minimal and maximal size explicitly set for the window, if any. So even if some window believes that it needs 200 pixels horizontally, calling SetMaxSize() with a width of 100 would ensure that GetBestSize() returns the width of at most 100 pixels.

See also
  CacheBestSize(), Window Sizing Overview

## ◆ GetBestVirtualSize()

virtual wxSize wxWindow::GetBestVirtualSize | ( |  | ) | const
| virtual

Return the largest of ClientSize and BestSize (as determined by a sizer, interior children, or other means)

## ◆ GetBestWidth()

int wxWindow::GetBestWidth | ( | int | height | ) | const

Returns the best width needed by this window if it had the given height.

See also
  DoGetBestClientWidth()

Since
  2.9.4

## ◆ GetBorder() [1/2]

wxBorder wxWindow::GetBorder | ( | long | flags | ) | const

Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable.

## ◆ GetBorder() [2/2]

wxBorder wxWindow::GetBorder | ( |  | ) | const

Get border for the flags of this window.

## ◆ GetCapture()

static wxWindow* wxWindow::GetCapture | ( |  | ) |
| static

Returns the currently captured window.

See also
  HasCapture(), CaptureMouse(), ReleaseMouse(), wxMouseCaptureLostEvent, wxMouseCaptureChangedEvent

## ◆ GetCaret()

wxCaret* wxWindow::GetCaret | ( |  | ) | const

Returns the caret() associated with the window.

## ◆ GetCharHeight()

virtual int wxWindow::GetCharHeight | ( |  | ) | const
| virtual

Returns the character height for this window.

## ◆ GetCharWidth()

virtual int wxWindow::GetCharWidth | ( |  | ) | const
| virtual

Returns the average character width for this window.

## ◆ GetChildren() [1/2]

wxWindowList& wxWindow::GetChildren | ( |  | ) |

Returns a reference to the list of the window's children.

`wxWindowList` is a type-safe wxList-like class whose elements are of type `wxWindow*`.

## ◆ GetChildren() [2/2]

const wxWindowList& wxWindow::GetChildren | ( |  | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ GetClassDefaultAttributes()

static wxVisualAttributes wxWindow::GetClassDefaultAttributes | ( | wxWindowVariant | variant = `wxWINDOW_VARIANT_NORMAL` | ) |
| static

Returns the default font and colours which are used by the control.

This is useful if you want to use the same font or colour in your own control as in a standard control – which is a much better idea than hard coding specific colours or fonts which might look completely out of place on the users system, especially if it uses themes.

The variant parameter is only relevant under Mac currently and is ignore under other platforms. Under Mac, it will change the size of the returned font. See SetWindowVariant() for more about this.

This static method is "overridden" in many derived classes and so calling, for example, wxButton::GetClassDefaultAttributes() will typically return the values appropriate for a button which will be normally different from those returned by, say, wxListCtrl::GetClassDefaultAttributes().

The `wxVisualAttributes` structure has at least the fields `font`, `colFg` and `colBg`. All of them may be invalid if it was not possible to determine the default control appearance or, especially for the background colour, if the field doesn't make sense as is the case for `colBg` for the controls with themed background.

See also
  InheritAttributes()

## ◆ GetClientAreaOrigin()

virtual wxPoint wxWindow::GetClientAreaOrigin | ( |  | ) | const
| virtual

Get the origin of the client area of the window relative to the window top left corner (the client area may be shifted because of the borders, scrollbars, other decorations...)

Reimplemented in wxFrame.

## ◆ GetClientRect()

wxRect wxWindow::GetClientRect | ( |  | ) | const

Get the client rectangle in window (i.e. client) coordinates.

## ◆ GetClientSize() [1/2]

void wxWindow::GetClientSize | ( | int * | width,
|  | int * | height
| ) |  | const

Returns the size of the window 'client area' in pixels.

The client area is the area which may be drawn on by the programmer, excluding title bar, border, scrollbars, etc. Note that if this window is a top-level one and it is currently minimized, the return size is empty (both width and height are 0).

wxPerl Note: In wxPerl this method takes no parameters and returns a 2-element list (width, height).

See also
  GetSize(), GetVirtualSize()

## ◆ GetClientSize() [2/2]

wxSize wxWindow::GetClientSize | ( |  | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ GetConstraints()

wxLayoutConstraints* wxWindow::GetConstraints | ( |  | ) | const

Returns a pointer to the window's layout constraints, or NULL if there are none.

## ◆ GetContainingSizer()

wxSizer* wxWindow::GetContainingSizer | ( |  | ) | const

Returns the sizer of which this window is a member, if any, otherwise NULL.

## ◆ GetContentScaleFactor()

virtual double wxWindow::GetContentScaleFactor | ( |  | ) | const
| virtual

Returns the magnification of the backing store of this window, eg 2.0 for a window on a retina screen.

Since
  2.9.5

## ◆ GetCursor()

const wxCursor& wxWindow::GetCursor | ( |  | ) | const

Return the cursor associated with this window.

See also
  SetCursor()

## ◆ GetDefaultAttributes()

virtual wxVisualAttributes wxWindow::GetDefaultAttributes | ( |  | ) | const
| virtual

Currently this is the same as calling wxWindow::GetClassDefaultAttributes(wxWindow::GetWindowVariant()).

One advantage of using this function compared to the static version is that the call is automatically dispatched to the correct class (as usual with virtual functions) and you don't have to specify the class name explicitly.

The other one is that in the future this function could return different results, for example it might return a different font for an "Ok" button than for a generic button if the users GUI is configured to show such buttons in bold font. Of course, the down side is that it is impossible to call this function without actually having an object to apply it to whereas the static version can be used without having to create an object first.

## ◆ GetDropTarget()

virtual wxDropTarget* wxWindow::GetDropTarget | ( |  | ) | const
| virtual

Returns the associated drop target, which may be NULL.

See also
  SetDropTarget(), Drag and Drop Overview

## ◆ GetEffectiveMinSize()

virtual wxSize wxWindow::GetEffectiveMinSize | ( |  | ) | const
| virtual

Merges the window's best size into the min size and returns the result.

This is the value used by sizers to determine the appropriate amount of space to allocate for the widget.

This is the method called by a wxSizer when it queries the size of a window or control.

See also
  GetBestSize(), SetInitialSize(), Window Sizing Overview

## ◆ GetEventHandler()

wxEvtHandler* wxWindow::GetEventHandler | ( |  | ) | const

Returns the event handler for this window.

By default, the window is its own event handler.

See also
  SetEventHandler(), PushEventHandler(), PopEventHandler(), wxEvtHandler::ProcessEvent, wxEvtHandler

## ◆ GetExtraStyle()

long wxWindow::GetExtraStyle | ( |  | ) | const

Returns the extra style bits for the window.

## ◆ GetFont()

wxFont wxWindow::GetFont | ( |  | ) | const

Returns the font for this window.

See also
  SetFont()

## ◆ GetForegroundColour()

wxColour wxWindow::GetForegroundColour | ( |  | ) | const

Returns the foreground colour of the window.

Remarks
  The meaning of foreground colour varies according to the window class; it may be the text colour or other colour, or it may not be used at all.

See also
  SetForegroundColour(), SetBackgroundColour(), GetBackgroundColour()

## ◆ GetGrandParent()

wxWindow* wxWindow::GetGrandParent | ( |  | ) | const

Returns the grandparent of a window, or NULL if there isn't one.

## ◆ GetHandle()

virtual WXWidget wxWindow::GetHandle | ( |  | ) | const
| virtual

Returns the platform-specific handle of the physical window.

Cast it to an appropriate handle, such as HWND for Windows, Widget for Motif or GtkWidget for GTK.

wxPerl Note: This method will return an integer in wxPerl.

## ◆ GetHelpText()

wxString wxWindow::GetHelpText | ( |  | ) | const

Gets the help text to be used as context-sensitive help for this window.

Note that the text is actually stored by the current wxHelpProvider implementation, and not in the window object itself.

See also
  SetHelpText(), GetHelpTextAtPoint(), wxHelpProvider

## ◆ GetHelpTextAtPoint()

virtual wxString wxWindow::GetHelpTextAtPoint | ( | const wxPoint & | point,
|  | wxHelpEvent::Origin | origin
| ) |  | const
| virtual

Gets the help text to be used as context-sensitive help for this window.

This method should be overridden if the help message depends on the position inside the window, otherwise GetHelpText() can be used.

Parameters

  point | Coordinates of the mouse at the moment of help event emission.
  origin | Help event origin, see also wxHelpEvent::GetOrigin.

## ◆ GetId()

wxWindowID wxWindow::GetId | ( |  | ) | const

Returns the identifier of the window.

Remarks
  Each window has an integer identifier. If the application has not provided one (or the default wxID_ANY) a unique identifier with a negative value will be generated.

See also
  SetId(), Window IDs

## ◆ GetLabel()

virtual wxString wxWindow::GetLabel | ( |  | ) | const
| virtual

Generic way of getting a label from any window, for identification purposes.

Remarks
  The interpretation of this function differs from class to class. For frames and dialogs, the value returned is the title. For buttons or static text controls, it is the button text. This function can be useful for meta-programs (such as testing tools or special-needs access programs) which need to identify windows by name.

Reimplemented in wxButton, wxControl, and wxCommandLinkButton.

## ◆ GetLayoutDirection()

virtual wxLayoutDirection wxWindow::GetLayoutDirection | ( |  | ) | const
| virtual

Returns the layout direction for this window, Note that `wxLayout_Default` is returned if layout direction is not supported.

## ◆ GetMaxClientSize()

virtual wxSize wxWindow::GetMaxClientSize | ( |  | ) | const
| virtual

Returns the maximum size of window's client area.

This is an indication to the sizer layout mechanism that this is the maximum possible size as well as the upper bound on window's size settable using SetClientSize().

See also
  GetMaxSize(), Window Sizing Overview

## ◆ GetMaxHeight()

int wxWindow::GetMaxHeight | ( |  | ) | const

Returns the vertical component of window maximal size.

The returned value is wxDefaultCoord if the maximal width was not set.

See also
  GetMaxSize()

## ◆ GetMaxSize()

virtual wxSize wxWindow::GetMaxSize | ( |  | ) | const
| virtual

Returns the maximum size of the window.

This is an indication to the sizer layout mechanism that this is the maximum possible size as well as the upper bound on window's size settable using SetSize().

See also
  GetMaxClientSize(), Window Sizing Overview

## ◆ GetMaxWidth()

int wxWindow::GetMaxWidth | ( |  | ) | const

Returns the horizontal component of window maximal size.

The returned value is wxDefaultCoord if the maximal width was not set.

See also
  GetMaxSize()

## ◆ GetMinClientSize()

virtual wxSize wxWindow::GetMinClientSize | ( |  | ) | const
| virtual

Returns the minimum size of window's client area, an indication to the sizer layout mechanism that this is the minimum required size of its client area.

It normally just returns the value set by SetMinClientSize(), but it can be overridden to do the calculation on demand.

See also
  GetMinSize(), Window Sizing Overview

## ◆ GetMinHeight()

int wxWindow::GetMinHeight | ( |  | ) | const

Returns the vertical component of window minimal size.

The returned value is wxDefaultCoord if the minimal height was not set.

See also
  GetMinSize()

## ◆ GetMinSize()

virtual wxSize wxWindow::GetMinSize | ( |  | ) | const
| virtual

Returns the minimum size of the window, an indication to the sizer layout mechanism that this is the minimum required size.

This method normally just returns the value set by SetMinSize(), but it can be overridden to do the calculation on demand.

See also
  GetMinClientSize(), Window Sizing Overview

## ◆ GetMinWidth()

int wxWindow::GetMinWidth | ( |  | ) | const

Returns the horizontal component of window minimal size.

The returned value is wxDefaultCoord if the minimal width was not set.

See also
  GetMinSize()

## ◆ GetName()

virtual wxString wxWindow::GetName | ( |  | ) | const
| virtual

Returns the window's name.

Remarks
  This name is not guaranteed to be unique; it is up to the programmer to supply an appropriate name in the window constructor or via SetName().

See also
  SetName()

## ◆ GetNextSibling()

wxWindow* wxWindow::GetNextSibling | ( |  | ) | const

Returns the next window after this one among the parent's children or NULL if this window is the last child.

Since
  2.8.8

See also
  GetPrevSibling()

## ◆ GetParent()

wxWindow* wxWindow::GetParent | ( |  | ) | const

Returns the parent of the window, or NULL if there is no parent.

## ◆ GetPopupMenuSelectionFromUser() [1/2]

int wxWindow::GetPopupMenuSelectionFromUser | ( | wxMenu & | menu,
|  | const wxPoint & | pos = `wxDefaultPosition`
| ) |  |

This function shows a popup menu at the given position in this window and returns the selected id.

It can be more convenient than the general purpose PopupMenu() function for simple menus proposing a choice in a list of strings to the user.

Notice that to avoid unexpected conflicts between the (usually consecutive range of) ids used by the menu passed to this function and the existing EVT_UPDATE_UI() handlers, this function temporarily disables UI updates for the window, so you need to manually disable (or toggle or ...) any items which should be disabled in the menu before showing it.

The parameter menu is the menu to show. The parameter pos (or the parameters x and y) is the position at which to show the menu in client coordinates. It is recommended to not explicitly specify coordinates when calling this method in response to mouse click, because some of the ports (namely, wxGTK) can do a better job of positioning the menu in that case.

Returns
  The selected menu item id or `wxID_NONE` if none selected or an error occurred.

Since
  2.9.0

## ◆ GetPopupMenuSelectionFromUser() [2/2]

int wxWindow::GetPopupMenuSelectionFromUser | ( | wxMenu & | menu,
|  | int | x,
|  | int | y
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ GetPosition() [1/2]

void wxWindow::GetPosition | ( | int * | x,
|  | int * | y
| ) |  | const

This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows.

Parameters

  x | Receives the x position of the window if non-NULL.
  y | Receives the y position of the window if non-NULL.

wxPerl Note: In wxPerl this method is implemented as GetPositionXY() returning a 2-element list (x, y).

See also
  GetScreenPosition()

## ◆ GetPosition() [2/2]

wxPoint wxWindow::GetPosition | ( |  | ) | const

This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows.

See also
  GetScreenPosition()

## ◆ GetPrevSibling()

wxWindow* wxWindow::GetPrevSibling | ( |  | ) | const

Returns the previous window before this one among the parent's children or `` NULL if this window is the first child.

Since
  2.8.8

See also
  GetNextSibling()

## ◆ GetRect()

wxRect wxWindow::GetRect | ( |  | ) | const

Returns the position and size of the window as a wxRect object.

See also
  GetScreenRect()

## ◆ GetScreenPosition() [1/2]

void wxWindow::GetScreenPosition | ( | int * | x,
|  | int * | y
| ) |  | const

Returns the window position in screen coordinates, whether the window is a child window or a top level one.

Parameters

  x | Receives the x position of the window on the screen if non-NULL.
  y | Receives the y position of the window on the screen if non-NULL.

See also
  GetPosition()

## ◆ GetScreenPosition() [2/2]

wxPoint wxWindow::GetScreenPosition | ( |  | ) | const

Returns the window position in screen coordinates, whether the window is a child window or a top level one.

See also
  GetPosition()

## ◆ GetScreenRect()

wxRect wxWindow::GetScreenRect | ( |  | ) | const

Returns the position and size of the window on the screen as a wxRect object.

See also
  GetRect()

## ◆ GetScrollPos()

virtual int wxWindow::GetScrollPos | ( | int | orientation | ) | const
| virtual

Returns the built-in scrollbar position.

See also
  SetScrollbar()

## ◆ GetScrollRange()

virtual int wxWindow::GetScrollRange | ( | int | orientation | ) | const
| virtual

Returns the built-in scrollbar range.

See also
  SetScrollbar()

## ◆ GetScrollThumb()

virtual int wxWindow::GetScrollThumb | ( | int | orientation | ) | const
| virtual

Returns the built-in scrollbar thumb size.

See also
  SetScrollbar()

## ◆ GetSize() [1/2]

void wxWindow::GetSize | ( | int * | width,
|  | int * | height
| ) |  | const

Returns the size of the entire window in pixels, including title bar, border, scrollbars, etc.

Note that if this window is a top-level one and it is currently minimized, the returned size is the restored window size, not the size of the window icon.

Parameters

  width | Receives the window width.
  height | Receives the window height.

wxPerl Note: In wxPerl this method is implemented as GetSizeWH() returning a 2-element list (width, height).

See also
  GetClientSize(), GetVirtualSize(), Window Sizing Overview

## ◆ GetSize() [2/2]

wxSize wxWindow::GetSize | ( |  | ) | const

See the GetSize(int*,int*) overload for more info.

## ◆ GetSizer()

wxSizer* wxWindow::GetSizer | ( |  | ) | const

Returns the sizer associated with the window by a previous call to SetSizer(), or NULL.

## ◆ GetTextExtent() [1/2]

void wxWindow::GetTextExtent | ( | const wxString & | string,
|  | int * | w,
|  | int * | h,
|  | int * | descent = `NULL`,
|  | int * | externalLeading = `NULL`,
|  | const wxFont * | font = `NULL`
| ) |  | const

Gets the dimensions of the string as it would be drawn on the window with the currently selected font.

The text extent is returned in the w and h pointers.

Parameters

  string | String whose extent is to be measured.
  w | Return value for width.
  h | Return value for height.
  descent | Return value for descent (optional).
  externalLeading | Return value for external leading (optional).
  font | Font to use instead of the current window font (optional).

wxPerl Note: In wxPerl this method takes only the string and optionally font parameters, and returns a 4-element list (x, y, descent, externalLeading).

## ◆ GetTextExtent() [2/2]

wxSize wxWindow::GetTextExtent | ( | const wxString & | string | ) | const

Gets the dimensions of the string as it would be drawn on the window with the currently selected font.

## ◆ GetThemeEnabled()

virtual bool wxWindow::GetThemeEnabled | ( |  | ) | const
| virtual

Clears the window by filling it with the current background colour.

Does not cause an erase background event to be generated.

Notice that this uses wxClientDC to draw on the window and the results of doing it while also drawing on wxPaintDC for this window are undefined. Hence this method shouldn't be used from EVT_PAINT handlers, just use wxDC::Clear() on the wxPaintDC you already use there instead.

## ◆ GetToolTip()

wxToolTip* wxWindow::GetToolTip | ( |  | ) | const

Get the associated tooltip or NULL if none.

## ◆ GetToolTipText()

wxString wxWindow::GetToolTipText | ( |  | ) | const

Get the text of the associated tooltip or empty string if none.

## ◆ GetUpdateClientRect()

wxRect wxWindow::GetUpdateClientRect | ( |  | ) | const

Get the update rectangle bounding box in client coords.

## ◆ GetUpdateRegion()

const wxRegion& wxWindow::GetUpdateRegion | ( |  | ) | const

Returns the region specifying which parts of the window have been damaged.

Should only be called within an wxPaintEvent handler.

See also
  wxRegion, wxRegionIterator

## ◆ GetValidator()

virtual wxValidator* wxWindow::GetValidator | ( |  | ) |
| virtual

Validator functions.

Returns a pointer to the current validator for the window, or NULL if there is none.

## ◆ GetVirtualSize() [1/2]

wxSize wxWindow::GetVirtualSize | ( |  | ) | const

This gets the virtual size of the window in pixels.

By default it returns the client size of the window, but after a call to SetVirtualSize() it will return the size set with that method.

See also
  Window Sizing Overview

## ◆ GetVirtualSize() [2/2]

void wxWindow::GetVirtualSize | ( | int * | width,
|  | int * | height
| ) |  | const

Like the other GetVirtualSize() overload but uses pointers instead.

Parameters

  width | Receives the window virtual width.
  height | Receives the window virtual height.

## ◆ GetWindowBorderSize()

virtual wxSize wxWindow::GetWindowBorderSize | ( |  | ) | const
| virtual

Returns the size of the left/right and top/bottom borders of this window in x and y components of the result respectively.

## ◆ GetWindowStyle()

long wxWindow::GetWindowStyle | ( |  | ) | const

See GetWindowStyleFlag() for more info.

## ◆ GetWindowStyleFlag()

virtual long wxWindow::GetWindowStyleFlag | ( |  | ) | const
| virtual

Gets the window style that was passed to the constructor or Create() method.

GetWindowStyle() is another name for the same function.

Reimplemented in wxAuiToolBar.

## ◆ GetWindowVariant()

wxWindowVariant wxWindow::GetWindowVariant | ( |  | ) | const

Returns the value previously passed to SetWindowVariant().

## ◆ HandleAsNavigationKey()

bool wxWindow::HandleAsNavigationKey | ( | const wxKeyEvent & | event | ) |

This function will generate the appropriate call to Navigate() if the key event is one normally used for keyboard navigation and return true in this case.

Returns
  Returns true if the key pressed was for navigation and was handled, false otherwise.

See also
  Navigate()

## ◆ HandleWindowEvent()

bool wxWindow::HandleWindowEvent | ( | wxEvent & | event | ) | const

Shorthand for:

GetEventHandler()->SafelyProcessEvent(event);

See also
  ProcessWindowEvent()

## ◆ HasCapture()

virtual bool wxWindow::HasCapture | ( |  | ) | const
| virtual

Returns true if this window has the current mouse capture.

See also
  CaptureMouse(), ReleaseMouse(), wxMouseCaptureLostEvent, wxMouseCaptureChangedEvent

## ◆ HasExtraStyle()

bool wxWindow::HasExtraStyle | ( | int | exFlag | ) | const

Returns true if the window has the given exFlag bit set in its extra styles.

See also
  SetExtraStyle()

## ◆ HasFlag()

bool wxWindow::HasFlag | ( | int | flag | ) | const

Returns true if the window has the given flag bit set.

## ◆ HasFocus()

virtual bool wxWindow::HasFocus | ( |  | ) | const
| virtual

Returns true if the window (or in case of composite controls, its main child window) has focus.

Since
  2.9.0

See also
  FindFocus()

## ◆ HasMultiplePages()

virtual bool wxWindow::HasMultiplePages | ( |  | ) | const
| virtual

This method should be overridden to return true if this window has multiple pages.

All standard class with multiple pages such as wxNotebook, wxListbook and wxTreebook already override it to return true and user-defined classes with similar behaviour should also do so, to allow the library to handle such windows appropriately.

## ◆ HasScrollbar()

bool wxWindow::HasScrollbar | ( | int | orient | ) | const

Returns true if this window currently has a scroll bar for this orientation.

This method may return false even when CanScroll() for the same orientation returns true, but if CanScroll() returns false, i.e. scrolling in this direction is not enabled at all, HasScrollbar() always returns false as well.

Parameters

  orient | Orientation to check, either wxHORIZONTAL or wxVERTICAL.

## ◆ HasTransparentBackground()

virtual bool wxWindow::HasTransparentBackground | ( |  | ) |
| virtual

Returns true if this window background is transparent (as, for example, for wxStaticText) and should show the parent window background.

This method is mostly used internally by the library itself and you normally shouldn't have to call it. You may, however, have to override it in your wxWindow-derived class to ensure that background is painted correctly.

## ◆ Hide()

bool wxWindow::Hide | ( |  | ) |

Equivalent to calling wxWindow::Show(false).

## ◆ HideWithEffect()

virtual bool wxWindow::HideWithEffect | ( | wxShowEffect | effect,
|  | unsigned int | timeout = `0`
| ) |  |
| virtual

This function hides a window, like Hide(), but using a special visual effect if possible.

The parameters of this function are the same as for ShowWithEffect(), please see their description there.

Since
  2.9.0

## ◆ HitTest() [1/2]

wxHitTest wxWindow::HitTest | ( | wxCoord | x,
|  | wxCoord | y
| ) |  | const

Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable.

## ◆ HitTest() [2/2]

wxHitTest wxWindow::HitTest | ( | const wxPoint & | pt | ) | const

Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable.

## ◆ InformFirstDirection()

virtual bool wxWindow::InformFirstDirection | ( | int | direction,
|  | int | size,
|  | int | availableOtherDir
| ) |  |
| virtual

wxSizer and friends use this to give a chance to a component to recalc its min size once one of the final size components is known.

Override this function when that is useful (such as for wxStaticText which can stretch over several lines). Parameter availableOtherDir tells the item how much more space there is available in the opposite direction (-1 if unknown).

## ◆ InheritAttributes()

virtual void wxWindow::InheritAttributes | ( |  | ) |
| virtual

This function is (or should be, in case of custom controls) called during window creation to intelligently set up the window visual attributes, that is the font and the foreground and background colours.

By "intelligently" the following is meant: by default, all windows use their own GetClassDefaultAttributes() default attributes. However if some of the parents attributes are explicitly (that is, using SetFont() and not wxWindow::SetOwnFont) changed and if the corresponding attribute hadn't been explicitly set for this window itself, then this window takes the same value as used by the parent. In addition, if the window overrides ShouldInheritColours() to return false, the colours will not be changed no matter what and only the font might.

This rather complicated logic is necessary in order to accommodate the different usage scenarios. The most common one is when all default attributes are used and in this case, nothing should be inherited as in modern GUIs different controls use different fonts (and colours) than their siblings so they can't inherit the same value from the parent. However it was also deemed desirable to allow to simply change the attributes of all children at once by just changing the font or colour of their common parent, hence in this case we do inherit the parents attributes.

## ◆ InheritsBackgroundColour()

bool wxWindow::InheritsBackgroundColour | ( |  | ) | const

Return true if this window inherits the background colour from its parent.

See also
  SetOwnBackgroundColour(), InheritAttributes()

## ◆ InitDialog()

virtual void wxWindow::InitDialog | ( |  | ) |
| virtual

Sends an `wxEVT_INIT_DIALOG` event, whose handler usually transfers data to the dialog via validators.

Reimplemented in wxPanel.

## ◆ InvalidateBestSize()

void wxWindow::InvalidateBestSize | ( |  | ) |

Resets the cached best size value so it will be recalculated the next time it is needed.

See also
  CacheBestSize()

## ◆ IsBeingDeleted()

bool wxWindow::IsBeingDeleted | ( |  | ) | const

Returns true if this window is in process of being destroyed.

Top level windows are not deleted immediately but are rather scheduled for later destruction to give them time to process any pending messages; see Destroy() description.

This function returns true if this window, or one of its parent windows, is scheduled for destruction and can be useful to avoid manipulating it as it's usually useless to do something with a window which is on the point of disappearing anyhow.

## ◆ IsDescendant()

bool wxWindow::IsDescendant | ( | wxWindowBase * | win | ) | const

Check if the specified window is a descendant of this one.

Returns true if the window is a descendant (i.e. a child or grand-child or grand-grand-child or ...) of this one.

Notice that a window can never be a descendant of another one if they are in different top level windows, i.e. a child of a wxDialog is not considered to be a descendant of dialogs parent wxFrame.

Parameters

  win | Any window, possible NULL (false is always returned then).

Since
  2.9.4

## ◆ IsDoubleBuffered()

virtual bool wxWindow::IsDoubleBuffered | ( |  | ) | const
| virtual

Returns true if the window contents is double-buffered by the system, i.e. if any drawing done on the window is really done on a temporary backing surface and transferred to the screen all at once later.

See also
  wxBufferedDC

## ◆ IsEnabled()

bool wxWindow::IsEnabled | ( |  | ) | const

Returns true if the window is enabled, i.e. if it accepts user input, false otherwise.

Notice that this method can return false even if this window itself hadn't been explicitly disabled when one of its parent windows is disabled. To get the intrinsic status of this window, use IsThisEnabled()

See also
  Enable()

## ◆ IsExposed() [1/4]

bool wxWindow::IsExposed | ( | int | x,
|  | int | y
| ) |  | const

Returns true if the given point or rectangle area has been exposed since the last repaint.

Call this in an paint event handler to optimize redrawing by only redrawing those areas, which have been exposed.

## ◆ IsExposed() [2/4]

bool wxWindow::IsExposed | ( | wxPoint & | pt | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ IsExposed() [3/4]

bool wxWindow::IsExposed | ( | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ IsExposed() [4/4]

bool wxWindow::IsExposed | ( | wxRect & | rect | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ IsFocusable()

bool wxWindow::IsFocusable | ( |  | ) | const

Can this window itself have focus?

## ◆ IsFrozen()

bool wxWindow::IsFrozen | ( |  | ) | const

Returns true if the window is currently frozen by a call to Freeze().

See also
  Freeze(), Thaw()

## ◆ IsRetained()

virtual bool wxWindow::IsRetained | ( |  | ) | const
| virtual

Returns true if the window is retained, false otherwise.

Remarks
  Retained windows are only available on X platforms.

## ◆ IsScrollbarAlwaysShown()

virtual bool wxWindow::IsScrollbarAlwaysShown | ( | int | orient | ) | const
| virtual

Return whether a scrollbar is always shown.

Parameters

  orient | Orientation to check, either wxHORIZONTAL or wxVERTICAL.

See also
  AlwaysShowScrollbars()

## ◆ IsShown()

virtual bool wxWindow::IsShown | ( |  | ) | const
| virtual

Returns true if the window is shown, false if it has been hidden.

See also
  IsShownOnScreen()

## ◆ IsShownOnScreen()

virtual bool wxWindow::IsShownOnScreen | ( |  | ) | const
| virtual

Returns true if the window is physically visible on the screen, i.e. it is shown and all its parents up to the toplevel window are shown as well.

See also
  IsShown()

## ◆ IsThisEnabled()

bool wxWindow::IsThisEnabled | ( |  | ) | const

Returns true if this window is intrinsically enabled, false otherwise, i.e. if Enable() Enable(false) had been called.

This method is mostly used for wxWidgets itself, user code should normally use IsEnabled() instead.

## ◆ IsTopLevel()

virtual bool wxWindow::IsTopLevel | ( |  | ) | const
| virtual

Returns true if the given window is a top-level one.

Currently all frames and dialogs are considered to be top-level windows (even if they have a parent window).

Reimplemented in wxAuiMDIChildFrame.

## ◆ IsTransparentBackgroundSupported()

virtual bool wxWindow::IsTransparentBackgroundSupported | ( | wxString * | reason = `NULL` | ) | const
| virtual

Checks whether using transparent background might work.

If this function returns false, calling SetBackgroundStyle() with wxBG_STYLE_TRANSPARENT is not going to work. If it returns true, setting transparent style should normally succeed.

Notice that this function would typically be called on the parent of a window you want to set transparent background style for as the window for which this method is called must be fully created.

Parameters

  reason | If not NULL, a reason message is provided if transparency is not supported.

Returns
  true if background transparency is supported.

Since
  2.9.4

## ◆ Layout()

virtual bool wxWindow::Layout | ( |  | ) |
| virtual

Invokes the constraint-based layout algorithm or the sizer-based algorithm for this window.

This function does not get called automatically when the window is resized because lots of windows deriving from wxWindow does not need this functionality. If you want to have Layout() called automatically, you should derive from wxPanel (see wxPanel::Layout).

See also
  Window Sizing Overview

Reimplemented in wxTopLevelWindow, and wxPanel.

## ◆ LineDown()

bool wxWindow::LineDown | ( |  | ) |

Same as ScrollLines (1).

## ◆ LineUp()

bool wxWindow::LineUp | ( |  | ) |

Same as ScrollLines (-1).

## ◆ Lower()

virtual void wxWindow::Lower | ( |  | ) |
| virtual

Lowers the window to the bottom of the window hierarchy (Z-order).

Remarks
  This function only works for wxTopLevelWindow-derived classes.

See also
  Raise()

## ◆ Move() [1/2]

void wxWindow::Move | ( | int | x,
|  | int | y,
|  | int | flags = `wxSIZE_USE_EXISTING`
| ) |  |

Moves the window to the given position.

Parameters

  x | Required x position.
  y | Required y position.
  flags | See SetSize() for more info about this parameter.

Remarks
  Implementations of SetSize can also implicitly implement the Move() function, which is defined in the base wxWindow class as the call:
  SetSize(x, y, wxDefaultCoord, wxDefaultCoord, wxSIZE_USE_EXISTING);

See also
  SetSize()

## ◆ Move() [2/2]

void wxWindow::Move | ( | const wxPoint & | pt,
|  | int | flags = `wxSIZE_USE_EXISTING`
| ) |  |

Moves the window to the given position.

Parameters

  pt | wxPoint object representing the position.
  flags | See SetSize() for more info about this parameter.

Remarks
  Implementations of SetSize() can also implicitly implement the Move() function, which is defined in the base wxWindow class as the call:
  SetSize(x, y, wxDefaultCoord, wxDefaultCoord, wxSIZE_USE_EXISTING);

See also
  SetSize()

## ◆ MoveAfterInTabOrder()

void wxWindow::MoveAfterInTabOrder | ( | wxWindow * | win | ) |

Moves this window in the tab navigation order after the specified win.

This means that when the user presses `TAB` key on that other window, the focus switches to this window.

Default tab order is the same as creation order, this function and MoveBeforeInTabOrder() allow to change it after creating all the windows.

Parameters

  win | A sibling of this window which should precede it in tab order, must not be NULL

## ◆ MoveBeforeInTabOrder()

void wxWindow::MoveBeforeInTabOrder | ( | wxWindow * | win | ) |

Same as MoveAfterInTabOrder() except that it inserts this window just before win instead of putting it right after it.

## ◆ Navigate()

bool wxWindow::Navigate | ( | int | flags = `wxNavigationKeyEvent::IsForward` | ) |

Performs a keyboard navigation action starting from this window.

This method is equivalent to calling NavigateIn() method on the parent window.

Parameters

  flags | A combination of wxNavigationKeyEvent::IsForward and wxNavigationKeyEvent::WinChange.

Returns
  Returns true if the focus was moved to another window or false if nothing changed.

Remarks
  You may wish to call this from a text control custom keypress handler to do the default navigation behaviour for the tab key, since the standard default behaviour for a multiline text control with the wxTE_PROCESS_TAB style is to insert a tab and not navigate to the next control. See also wxNavigationKeyEvent and HandleAsNavigationKey.

## ◆ NavigateIn()

bool wxWindow::NavigateIn | ( | int | flags = `wxNavigationKeyEvent::IsForward` | ) |

Performs a keyboard navigation action inside this window.

See Navigate() for more information.

## ◆ NewControlId()

static wxWindowID wxWindow::NewControlId | ( | int | count = `1` | ) |
| static

Create a new ID or range of IDs that are not currently in use.

The IDs will be reserved until assigned to a wxWindow ID or unreserved with UnreserveControlId().

See Window IDs for more information.

Parameters

  count | The number of sequential IDs to reserve.

Returns
  Returns the ID or the first ID of the range (i.e. the most negative), or wxID_NONE if the specified number of identifiers couldn't be allocated.

See also
  UnreserveControlId(), wxIdManager, Window IDs

## ◆ OnInternalIdle()

virtual void wxWindow::OnInternalIdle | ( |  | ) |
| virtual

This virtual function is normally only used internally, but sometimes an application may need it to implement functionality that should not be disabled by an application defining an OnIdle handler in a derived class.

This function may be used to do delayed painting, for example, and most implementations call UpdateWindowUI() in order to send update events to the window in idle time.

## ◆ PageDown()

bool wxWindow::PageDown | ( |  | ) |

Same as ScrollPages (1).

## ◆ PageUp()

bool wxWindow::PageUp | ( |  | ) |

Same as ScrollPages (-1).

## ◆ PopEventHandler()

wxEvtHandler* wxWindow::PopEventHandler | ( | bool | deleteHandler = `false` | ) |

Removes and returns the top-most event handler on the event handler stack.

E.g. in the case of:

when calling `W->PopEventHandler()`, the event handler `A` will be removed and `B` will be the first handler of the stack.

Note that it's an error to call this function when no event handlers were pushed on this window (i.e. when the window itself is its only event handler).

Parameters

  deleteHandler | If this is true, the handler will be deleted after it is removed (and the returned value will be NULL).

See also
  How Events are Processed

## ◆ PopupMenu() [1/2]

bool wxWindow::PopupMenu | ( | wxMenu * | menu,
|  | const wxPoint & | pos = `wxDefaultPosition`
| ) |  |

Pops up the given menu at the specified coordinates, relative to this window, and returns control when the user has dismissed the menu.

If a menu item is selected, the corresponding menu event is generated and will be processed as usual. If coordinates are not specified, the current mouse cursor position is used.

menu is the menu to pop up.

The position where the menu will appear can be specified either as a wxPoint pos or by two integers (x and y).

Remarks
  Just before the menu is popped up, wxMenu::UpdateUI is called to ensure that the menu items are in the correct state. The menu does not get deleted by the window. It is recommended to not explicitly specify coordinates when calling PopupMenu in response to mouse click, because some of the ports (namely, wxGTK) can do a better job of positioning the menu in that case.

See also
  wxMenu

## ◆ PopupMenu() [2/2]

bool wxWindow::PopupMenu | ( | wxMenu * | menu,
|  | int | x,
|  | int | y
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ PostSizeEvent()

void wxWindow::PostSizeEvent | ( |  | ) |

Posts a size event to the window.

This is the same as SendSizeEvent() with `wxSEND_EVENT_POST` argument.

## ◆ PostSizeEventToParent()

void wxWindow::PostSizeEventToParent | ( |  | ) |

Posts a size event to the parent of this window.

This is the same as SendSizeEventToParent() with `wxSEND_EVENT_POST` argument.

## ◆ ProcessEvent()

virtual bool wxWindow::ProcessEvent | ( | wxEvent & | event | ) |
| protectedvirtual

This function is public in wxEvtHandler but protected in wxWindow because for wxWindows you should always call ProcessEvent() on the pointer returned by GetEventHandler() and not on the wxWindow object itself.

For convenience, a ProcessWindowEvent() method is provided as a synonym for

GetEventHandler()->ProcessEvent()

Note that it's still possible to call these functions directly on the wxWindow object (e.g. casting it to wxEvtHandler) but doing that will create subtle bugs when windows with event handlers pushed on them are involved.

This holds also for all other wxEvtHandler functions.

Reimplemented from wxEvtHandler.

## ◆ ProcessPendingEvents()

void wxWindow::ProcessPendingEvents | ( |  | ) |
| protected

See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.

## ◆ ProcessThreadEvent()

bool wxWindow::ProcessThreadEvent | ( | const wxEvent & | event | ) |
| protected

See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.

## ◆ ProcessWindowEvent()

bool wxWindow::ProcessWindowEvent | ( | wxEvent & | event | ) |

Convenient wrapper for ProcessEvent().

This is the same as writing

GetEventHandler()->ProcessEvent(event);

but more convenient. Notice that ProcessEvent() itself can't be called for wxWindow objects as it ignores the event handlers associated with the window; use this function instead.

## ◆ ProcessWindowEventLocally()

bool wxWindow::ProcessWindowEventLocally | ( | wxEvent & | event | ) |

Wrapper for wxEvtHandler::ProcessEventLocally().

This method is similar to ProcessWindowEvent() but can be used to search for the event handler only in this window and any event handlers pushed on top of it. Unlike ProcessWindowEvent() it won't propagate the event upwards. But it will use the validator and event handlers associated with this window, if any.

Since
  2.9.1

## ◆ PushEventHandler()

void wxWindow::PushEventHandler | ( | wxEvtHandler * | handler | ) |

Pushes this event handler onto the event stack for the window.

An event handler is an object that is capable of processing the events sent to a window. By default, the window is its own event handler, but an application may wish to substitute another, for example to allow central implementation of event-handling for a variety of different window classes.

wxWindow::PushEventHandler allows an application to set up a stack of event handlers, where an event not handled by one event handler is handed to the next one in the chain.

E.g. if you have two event handlers `A` and `B` and a wxWindow instance `W` and you call:

W->PushEventHandler(A);
W->PushEventHandler(B);

you will end up with the following situation:

Note that you can use wxWindow::PopEventHandler to remove the event handler.

Parameters

  handler | Specifies the handler to be pushed. It must not be part of a wxEvtHandler chain; an assert will fail if it's not unlinked (see wxEvtHandler::IsUnlinked).

See also
  How Events are Processed

## ◆ QueueEvent()

virtual void wxWindow::QueueEvent | ( | wxEvent * | event | ) |
| protectedvirtual

See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.

Reimplemented from wxEvtHandler.

## ◆ Raise()

virtual void wxWindow::Raise | ( |  | ) |
| virtual

Raises the window to the top of the window hierarchy (Z-order).

Notice that this function only requests the window manager to raise this window to the top of Z-order. Depending on its configuration, the window manager may raise the window, not do it at all or indicate that a window requested to be raised in some other way, e.g. by flashing its icon if it is minimized.

Remarks
  This function only works for wxTopLevelWindow-derived classes.

See also
  Lower()

## ◆ Refresh()

virtual void wxWindow::Refresh | ( | bool | eraseBackground = `true`,
|  | const wxRect * | rect = `NULL`
| ) |  |
| virtual

Causes this window, and all of its children recursively (except under wxGTK1 where this is not implemented), to be repainted.

Note that repainting doesn't happen immediately but only during the next event loop iteration, if you need to update the window immediately you should use Update() instead.

Parameters

  eraseBackground | If true, the background will be erased.
  rect | If non-NULL, only the given rectangle will be treated as damaged.

See also
  RefreshRect()

Reimplemented in wxMenuBar.

## ◆ RefreshRect()

void wxWindow::RefreshRect | ( | const wxRect & | rect,
|  | bool | eraseBackground = `true`
| ) |  |

Redraws the contents of the given rectangle: only the area inside it will be repainted.

This is the same as Refresh() but has a nicer syntax as it can be called with a temporary wxRect object as argument like this `RefreshRect(wxRect(x, y, w, h))`.

## ◆ RegisterHotKey()

virtual bool wxWindow::RegisterHotKey | ( | int | hotkeyId,
|  | int | modifiers,
|  | int | virtualKeyCode
| ) |  |
| virtual

Registers a system wide hotkey.

Every time the user presses the hotkey registered here, this window will receive a hotkey event.

It will receive the event even if the application is in the background and does not have the input focus because the user is working with some other application.

Parameters

  hotkeyId | Numeric identifier of the hotkey. For applications this must be between 0 and 0xBFFF. If this function is called from a shared DLL, it must be a system wide unique identifier between 0xC000 and 0xFFFF. This is a MSW specific detail.
  modifiers | A bitwise combination of wxMOD_SHIFT, wxMOD_CONTROL, wxMOD_ALT or wxMOD_WIN specifying the modifier keys that have to be pressed along with the key.
  virtualKeyCode | The virtual key code of the hotkey.

Returns
  true if the hotkey was registered successfully. false if some other application already registered a hotkey with this modifier/virtualKeyCode combination.

Remarks
  Use EVT_HOTKEY(hotkeyId, fnc) in the event table to capture the event. This function is currently only implemented under Windows. It is used in the Windows CE port for detecting hardware button presses.

See also
  UnregisterHotKey()

## ◆ ReleaseMouse()

void wxWindow::ReleaseMouse | ( |  | ) |

Releases mouse input captured with CaptureMouse().

See also
  CaptureMouse(), HasCapture(), ReleaseMouse(), wxMouseCaptureLostEvent, wxMouseCaptureChangedEvent

## ◆ RemoveChild()

virtual void wxWindow::RemoveChild | ( | wxWindow * | child | ) |
| virtual

Removes a child window.

This is called automatically by window deletion functions so should not be required by the application programmer. Notice that this function is mostly internal to wxWidgets and shouldn't be called by the user code.

Parameters

  child | Child window to remove.

## ◆ RemoveEventHandler()

bool wxWindow::RemoveEventHandler | ( | wxEvtHandler * | handler | ) |

Find the given handler in the windows event handler stack and removes (but does not delete) it from the stack.

See wxEvtHandler::Unlink() for more info.

Parameters

  handler | The event handler to remove, must be non-NULL and must be present in this windows event handlers stack.

Returns
  Returns true if it was found and false otherwise (this also results in an assert failure so this function should only be called when the handler is supposed to be there).

See also
  PushEventHandler(), PopEventHandler()

## ◆ Reparent()

virtual bool wxWindow::Reparent | ( | wxWindow * | newParent | ) |
| virtual

Reparents the window, i.e. the window will be removed from its current parent window (e.g.

a non-standard toolbar in a wxFrame) and then re-inserted into another.

Notice that currently you need to explicitly call wxNotebook::RemovePage() before reparenting a notebook page.

Parameters

  newParent | New parent.

## ◆ SafelyProcessEvent()

bool wxWindow::SafelyProcessEvent | ( | wxEvent & | event | ) |
| protected

See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.

## ◆ ScreenToClient() [1/2]

void wxWindow::ScreenToClient | ( | int * | x,
|  | int * | y
| ) |  | const

Converts from screen to client window coordinates.

Parameters

  x | Stores the screen x coordinate and receives the client x coordinate.
  y | Stores the screen x coordinate and receives the client x coordinate.

## ◆ ScreenToClient() [2/2]

wxPoint wxWindow::ScreenToClient | ( | const wxPoint & | pt | ) | const

Converts from screen to client window coordinates.

Parameters

  pt | The screen position.

## ◆ ScrollLines()

virtual bool wxWindow::ScrollLines | ( | int | lines | ) |
| virtual

Scrolls the window by the given number of lines down (if lines is positive) or up.

Returns
  Returns true if the window was scrolled, false if it was already on top/bottom and nothing was done.

Remarks
  This function is currently only implemented under MSW and wxTextCtrl under wxGTK (it also works for wxScrolled classes under all platforms).

See also
  ScrollPages()

Reimplemented in wxRibbonGallery, and wxRibbonPage.

## ◆ ScrollPages()

virtual bool wxWindow::ScrollPages | ( | int | pages | ) |
| virtual

Scrolls the window by the given number of pages down (if pages is positive) or up.

Returns
  Returns true if the window was scrolled, false if it was already on top/bottom and nothing was done.

Remarks
  This function is currently only implemented under MSW and wxGTK.

See also
  ScrollLines()

## ◆ ScrollWindow()

virtual void wxWindow::ScrollWindow | ( | int | dx,
|  | int | dy,
|  | const wxRect * | rect = `NULL`
| ) |  |
| virtual

Physically scrolls the pixels in the window and move child windows accordingly.

Parameters

  dx | Amount to scroll horizontally.
  dy | Amount to scroll vertically.
  rect | Rectangle to scroll, if it is NULL, the whole window is scrolled (this is always the case under wxGTK which doesn't support this parameter)

Remarks
  Note that you can often use wxScrolled instead of using this function directly.

## ◆ SendDestroyEvent()

void wxWindow::SendDestroyEvent | ( |  | ) |
| protected

Generate wxWindowDestroyEvent for this window.

This is called by the window itself when it is being destroyed and usually there is no need to call it but see wxWindowDestroyEvent for explanations of when you might want to do it.

## ◆ SendIdleEvents()

virtual bool wxWindow::SendIdleEvents | ( | wxIdleEvent & | event | ) |
| virtual

Send idle event to window and all subwindows.

Returns true if more idle time is requested.

## ◆ SendSizeEvent()

virtual void wxWindow::SendSizeEvent | ( | int | flags = `0` | ) |
| virtual

This function sends a dummy size event to the window allowing it to re-layout its children positions.

It is sometimes useful to call this function after adding or deleting a children after the frame creation or if a child size changes. Note that if the frame is using either sizers or constraints for the children layout, it is enough to call wxWindow::Layout() directly and this function should not be used in this case.

If flags includes `wxSEND_EVENT_POST` value, this function posts the event, i.e. schedules it for later processing, instead of dispatching it directly. You can also use PostSizeEvent() as a more readable equivalent of calling this function with this flag.

Parameters

  flags | May include `wxSEND_EVENT_POST`. Default value is 0.

## ◆ SendSizeEventToParent()

void wxWindow::SendSizeEventToParent | ( | int | flags = `0` | ) |

Safe wrapper for GetParent()->SendSizeEvent().

This function simply checks that the window has a valid parent which is not in process of being deleted and calls SendSizeEvent() on it. It is used internally by windows such as toolbars changes to whose state should result in parent re-layout (e.g. when a toolbar is added to the top of the window, all the other windows must be shifted down).

See also
  PostSizeEventToParent()

Parameters

  flags | See description of this parameter in SendSizeEvent() documentation.

## ◆ SetAcceleratorTable()

virtual void wxWindow::SetAcceleratorTable | ( | const wxAcceleratorTable & | accel | ) |
| virtual

Sets the accelerator table for this window.

See wxAcceleratorTable.

## ◆ SetAccessible()

void wxWindow::SetAccessible | ( | wxAccessible * | accessible | ) |

Sets the accessible for this window.

Any existing accessible for this window will be deleted first, if not identical to accessible. See also wxAccessible.

## ◆ SetAutoLayout()

void wxWindow::SetAutoLayout | ( | bool | autoLayout | ) |

Determines whether the Layout() function will be called automatically when the window is resized.

This method is called implicitly by SetSizer() but if you use SetConstraints() you should call it manually or otherwise the window layout won't be correctly updated when its size changes.

Parameters

  autoLayout | Set this to true if you wish the Layout() function to be called automatically when the window is resized.

See also
  SetSizer(), SetConstraints()

## ◆ SetBackgroundColour()

virtual bool wxWindow::SetBackgroundColour | ( | const wxColour & | colour | ) |
| virtual

Sets the background colour of the window.

Notice that as with SetForegroundColour(), setting the background colour of a native control may not affect the entire control and could be not supported at all depending on the control and platform.

Please see InheritAttributes() for explanation of the difference between this method and SetOwnBackgroundColour().

Parameters

  colour | The colour to be used as the background colour; pass wxNullColour to reset to the default colour. Note that you may want to use wxSystemSettings::GetColour() to retrieve a suitable colour to use rather than setting an hard-coded one.

Remarks
  The background colour is usually painted by the default wxEraseEvent event handler function under Windows and automatically under GTK. Note that setting the background colour does not cause an immediate refresh, so you may wish to call wxWindow::ClearBackground or wxWindow::Refresh after calling this function. Using this function will disable attempts to use themes for this window, if the system supports them. Use with care since usually the themes represent the appearance chosen by the user to be used for all applications on the system.

Returns
  true if the colour was really changed, false if it was already set to this colour and nothing was done.

See also
  GetBackgroundColour(), SetForegroundColour(), GetForegroundColour(), ClearBackground(), Refresh(), wxEraseEvent, wxSystemSettings

Reimplemented in wxListCtrl.

## ◆ SetBackgroundStyle()

virtual bool wxWindow::SetBackgroundStyle | ( | wxBackgroundStyle | style | ) |
| virtual

Sets the background style of the window.

The default background style is `wxBG_STYLE_ERASE` which indicates that the window background may be erased in `EVT_ERASE_BACKGROUND` handler. This is a safe, compatibility default; however you may want to change it to `wxBG_STYLE_SYSTEM` if you don't define any erase background event handlers at all, to avoid unnecessary generation of erase background events and always let system erase the background. And you should change the background style to `wxBG_STYLE_PAINT` if you define an `EVT_PAINT` handler which completely overwrites the window background as in this case erasing it previously, either in `EVT_ERASE_BACKGROUND` handler or in the system default handler, would result in flicker as the background pixels will be repainted twice every time the window is redrawn. Do ensure that the background is entirely erased by your `EVT_PAINT` handler in this case however as otherwise garbage may be left on screen.

Notice that in previous versions of wxWidgets a common way to work around the above mentioned flickering problem was to define an empty `EVT_ERASE_BACKGROUND` handler. Setting background style to `wxBG_STYLE_PAINT` is a simpler and more efficient solution to the same problem.

Under wxGTK and wxOSX, you can use wxBG_STYLE_TRANSPARENT to obtain full transparency of the window background. Note that wxGTK supports this only since GTK 2.12 with a compositing manager enabled, call IsTransparentBackgroundSupported() to check whether this is the case.

Also, on order for `SetBackgroundStyle(wxBG_STYLE_TRANSPARENT)` to work, it must be called before Create(). If you're using your own wxWindow-derived class you should write your code in the following way:

class MyWidget : public wxWindow
{
public:
MyWidget(wxWindow* parent, ...)
: wxWindow() // Use default ctor here!
{
// Do this first:
SetBackgroundStyle(wxBG_STYLE_TRANSPARENT);
// And really create the window afterwards:
Create(parent, ...);
}
};

See also
  SetBackgroundColour(), GetForegroundColour(), SetTransparent(), IsTransparentBackgroundSupported()

## ◆ SetCanFocus()

virtual void wxWindow::SetCanFocus | ( | bool | canFocus | ) |
| virtual

This method is only implemented by ports which have support for native TAB traversal (such as GTK+ 2.0).

It is called by wxWidgets' container control code to give the native system a hint when doing TAB traversal. A call to this does not disable or change the effect of programmatically calling SetFocus().

See also
  wxFocusEvent, wxPanel::SetFocus, wxPanel::SetFocusIgnoringChildren

## ◆ SetCaret()

void wxWindow::SetCaret | ( | wxCaret * | caret | ) |

Sets the caret() associated with the window.

## ◆ SetClientSize() [1/3]

void wxWindow::SetClientSize | ( | int | width,
|  | int | height
| ) |  |

This sets the size of the window client area in pixels.

Using this function to size a window tends to be more device-independent than SetSize(), since the application need not worry about what dimensions the border or title bar have when trying to fit the window around panel items, for example.

See also
  Window Sizing Overview

## ◆ SetClientSize() [2/3]

void wxWindow::SetClientSize | ( | const wxSize & | size | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ SetClientSize() [3/3]

void wxWindow::SetClientSize | ( | const wxRect & | rect | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ SetConstraints()

void wxWindow::SetConstraints | ( | wxLayoutConstraints * | constraints | ) |

Sets the window to have the given layout constraints.

The window will then own the object, and will take care of its deletion. If an existing layout constraints object is already owned by the window, it will be deleted.

Parameters

  constraints | The constraints to set. Pass NULL to disassociate and delete the window's constraints.

Remarks
  You must call SetAutoLayout() to tell a window to use the constraints automatically in OnSize; otherwise, you must override OnSize and call Layout() explicitly. When setting both a wxLayoutConstraints and a wxSizer, only the sizer will have effect.

## ◆ SetContainingSizer()

void wxWindow::SetContainingSizer | ( | wxSizer * | sizer | ) |

This normally does not need to be called by user code.

It is called when a window is added to a sizer, and is used so the window can remove itself from the sizer when it is destroyed.

## ◆ SetCursor()

virtual bool wxWindow::SetCursor | ( | const wxCursor & | cursor | ) |
| virtual

Sets the window's cursor.

Notice that the window cursor also sets it for the children of the window implicitly.

The cursor may be `wxNullCursor` in which case the window cursor will be reset back to default.

Parameters

  cursor | Specifies the cursor that the window should normally display.

See also
  wxSetCursor, wxCursor

## ◆ SetDoubleBuffered()

void wxWindow::SetDoubleBuffered | ( | bool | on | ) |

Turn on or off double buffering of the window if the system supports it.

## ◆ SetDropTarget()

virtual void wxWindow::SetDropTarget | ( | wxDropTarget * | target | ) |
| virtual

Associates a drop target with this window.

If the window already has a drop target, it is deleted.

See also
  GetDropTarget(), Drag and Drop Overview

## ◆ SetEventHandler()

void wxWindow::SetEventHandler | ( | wxEvtHandler * | handler | ) |

Sets the event handler for this window.

Note that if you use this function you may want to use as the "next" handler of handler the window itself; in this way when handler doesn't process an event, the window itself will have a chance to do it.

Parameters

  handler | Specifies the handler to be set. Cannot be NULL.

See also
  How Events are Processed

## ◆ SetExtraStyle()

virtual void wxWindow::SetExtraStyle | ( | long | exStyle | ) |
| virtual

Sets the extra style bits for the window.

The currently defined extra style bits are reported in the class description.

## ◆ SetFocus()

virtual void wxWindow::SetFocus | ( |  | ) |
| virtual

This sets the window to receive keyboard input.

See also
  HasFocus(), wxFocusEvent, wxPanel::SetFocus, wxPanel::SetFocusIgnoringChildren

Reimplemented in wxPanel.

## ◆ SetFocusFromKbd()

virtual void wxWindow::SetFocusFromKbd | ( |  | ) |
| virtual

This function is called by wxWidgets keyboard navigation code when the user gives the focus to this window from keyboard (e.g.

using `TAB` key).

By default this method simply calls SetFocus() but can be overridden to do something in addition to this in the derived classes.

## ◆ SetFont()

virtual bool wxWindow::SetFont | ( | const wxFont & | font | ) |
| virtual

Sets the font for this window.

This function should not be called for the parent window if you don't want its font to be inherited by its children, use SetOwnFont() instead in this case and see InheritAttributes() for more explanations.

Please notice that the given font is not automatically used for wxPaintDC objects associated with this window, you need to call wxDC::SetFont too. However this font is used by any standard controls for drawing their text as well as by GetTextExtent().

Parameters

  font | Font to associate with this window, pass wxNullFont to reset to the default font.

Returns
  true if the font was really changed, false if it was already set to this font and nothing was done.

See also
  GetFont(), InheritAttributes()

Reimplemented in wxRichTextCtrl, wxAuiToolBar, wxAuiNotebook, and wxInfoBar.

## ◆ SetForegroundColour()

virtual bool wxWindow::SetForegroundColour | ( | const wxColour & | colour | ) |
| virtual

Sets the foreground colour of the window.

The meaning of foreground colour varies according to the window class; it may be the text colour or other colour, or it may not be used at all. Additionally, not all native controls support changing their foreground colour so this method may change their colour only partially or even not at all.

Please see InheritAttributes() for explanation of the difference between this method and SetOwnForegroundColour().

Parameters

  colour | The colour to be used as the foreground colour; pass wxNullColour to reset to the default colour.

Returns
  true if the colour was really changed, false if it was already set to this colour and nothing was done.

See also
  GetForegroundColour(), SetBackgroundColour(), GetBackgroundColour(), ShouldInheritColours()

## ◆ SetHelpText()

void wxWindow::SetHelpText | ( | const wxString & | helpText | ) |

Sets the help text to be used as context-sensitive help for this window.

Note that the text is actually stored by the current wxHelpProvider implementation, and not in the window object itself.

See also
  GetHelpText(), wxHelpProvider::AddHelp()

## ◆ SetId()

void wxWindow::SetId | ( | wxWindowID | winid | ) |

Sets the identifier of the window.

Remarks
  Each window has an integer identifier. If the application has not provided one, an identifier will be generated. Normally, the identifier should be provided on creation and should not be modified subsequently.

See also
  GetId(), Window IDs

## ◆ SetInitialBestSize()

virtual void wxWindow::SetInitialBestSize | ( | const wxSize & | size | ) |
| protectedvirtual

Sets the initial window size if none is given (i.e. at least one of the components of the size passed to ctor/Create() is wxDefaultCoord).

Deprecated:
  Use SetInitialSize() instead.

## ◆ SetInitialSize()

void wxWindow::SetInitialSize | ( | const wxSize & | size = `wxDefaultSize` | ) |

A smart SetSize that will fill in default size components with the window's best size values.

Also sets the window's minsize to the value passed in for use with sizers. This means that if a full or partial size is passed to this function then the sizers will use that size instead of the results of GetBestSize() to determine the minimum needs of the window for layout.

Most controls will use this to set their initial size, and their min size to the passed in value (if any.)

See also
  SetSize(), GetBestSize(), GetEffectiveMinSize(), Window Sizing Overview

## ◆ SetLabel()

virtual void wxWindow::SetLabel | ( | const wxString & | label | ) |
| virtual

Sets the window's label.

Parameters

  label | The window label.

See also
  GetLabel()

Reimplemented in wxButton, wxControl, and wxCommandLinkButton.

## ◆ SetLayoutDirection()

virtual void wxWindow::SetLayoutDirection | ( | wxLayoutDirection | dir | ) |
| virtual

Sets the layout direction for this window.

This function is only supported under MSW and GTK platforms, but not under Mac currently.

## ◆ SetMaxClientSize()

virtual void wxWindow::SetMaxClientSize | ( | const wxSize & | size | ) |
| virtual

Sets the maximum client size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size of its client area.

Note that this method is just a shortcut for:

SetMaxSize(ClientToWindowSize(size));

See also
  SetMaxSize(), Window Sizing Overview

## ◆ SetMaxSize()

virtual void wxWindow::SetMaxSize | ( | const wxSize & | size | ) |
| virtual

Sets the maximum size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size.

See also
  SetMaxClientSize(), Window Sizing Overview

Reimplemented in wxTopLevelWindow.

## ◆ SetMinClientSize()

virtual void wxWindow::SetMinClientSize | ( | const wxSize & | size | ) |
| virtual

Sets the minimum client size of the window, to indicate to the sizer layout mechanism that this is the minimum required size of window's client area.

You may need to call this if you change the window size after construction and before adding to its parent sizer.

Note, that just as with SetMinSize(), calling this method doesn't prevent the program from explicitly making the window smaller than the specified size.

Note that this method is just a shortcut for:

SetMinSize(ClientToWindowSize(size));

See also
  SetMinSize(), Window Sizing Overview

## ◆ SetMinSize()

virtual void wxWindow::SetMinSize | ( | const wxSize & | size | ) |
| virtual

Sets the minimum size of the window, to indicate to the sizer layout mechanism that this is the minimum required size.

You may need to call this if you change the window size after construction and before adding to its parent sizer.

Notice that calling this method doesn't prevent the program from making the window explicitly smaller than the specified size by calling SetSize(), it just ensures that it won't become smaller than this size during the automatic layout.

See also
  SetMinClientSize(), Window Sizing Overview

Reimplemented in wxTopLevelWindow.

## ◆ SetName()

virtual void wxWindow::SetName | ( | const wxString & | name | ) |
| virtual

Sets the window's name.

Parameters

  name | A name to set for the window.

See also
  GetName()

## ◆ SetNextHandler()

virtual void wxWindow::SetNextHandler | ( | wxEvtHandler * | handler | ) |
| virtual

wxWindows cannot be used to form event handler chains; this function thus will assert when called.

Note that instead you can use PushEventHandler() or SetEventHandler() to implement a stack of event handlers to override wxWindow's own event handling mechanism.

Reimplemented from wxEvtHandler.

## ◆ SetOwnBackgroundColour()

void wxWindow::SetOwnBackgroundColour | ( | const wxColour & | colour | ) |

Sets the background colour of the window but prevents it from being inherited by the children of this window.

See also
  SetBackgroundColour(), InheritAttributes()

## ◆ SetOwnFont()

void wxWindow::SetOwnFont | ( | const wxFont & | font | ) |

Sets the font of the window but prevents it from being inherited by the children of this window.

See also
  SetFont(), InheritAttributes()

## ◆ SetOwnForegroundColour()

void wxWindow::SetOwnForegroundColour | ( | const wxColour & | colour | ) |

Sets the foreground colour of the window but prevents it from being inherited by the children of this window.

See also
  SetForegroundColour(), InheritAttributes()

## ◆ SetPalette()

void wxWindow::SetPalette | ( | const wxPalette & | pal | ) |

Deprecated:
  use wxDC::SetPalette instead.

## ◆ SetPosition()

void wxWindow::SetPosition | ( | const wxPoint & | pt | ) |

Moves the window to the specified position.

This is exactly the same as calling Move() with the default arguments.

## ◆ SetPreviousHandler()

virtual void wxWindow::SetPreviousHandler | ( | wxEvtHandler * | handler | ) |
| virtual

wxWindows cannot be used to form event handler chains; this function thus will assert when called.

Note that instead you can use PushEventHandler() or SetEventHandler() to implement a stack of event handlers to override wxWindow's own event handling mechanism.

Reimplemented from wxEvtHandler.

## ◆ SetScrollbar()

virtual void wxWindow::SetScrollbar | ( | int | orientation,
|  | int | position,
|  | int | thumbSize,
|  | int | range,
|  | bool | refresh = `true`
| ) |  |
| virtual

Sets the scrollbar properties of a built-in scrollbar.

Parameters

  orientation | Determines the scrollbar whose page size is to be set. May be wxHORIZONTAL or wxVERTICAL.
  position | The position of the scrollbar in scroll units.
  thumbSize | The size of the thumb, or visible portion of the scrollbar, in scroll units.
  range | The maximum position of the scrollbar. Value of -1 can be used to ask for the scrollbar to be shown but in the disabled state: this can be used to avoid removing the scrollbar even when it is not needed (currently this is only implemented in wxMSW port).
  refresh | true to redraw the scrollbar, false otherwise.

Remarks
  Let's say you wish to display 50 lines of text, using the same font. The window is sized so that you can only see 16 lines at a time. You would use:
  SetScrollbar(wxVERTICAL, 0, 16, 50);
  Note that with the window at this size, the thumb position can never go above 50 minus 16, or 34. You can determine how many lines are currently visible by dividing the current view size by the character height in pixels. When defining your own scrollbar behaviour, you will always need to recalculate the scrollbar settings when the window size changes. You could therefore put your scrollbar calculations and SetScrollbar call into a function named AdjustScrollbars, which can be called initially and also from your wxSizeEvent handler function.

See also
  Scrolled Windows, wxScrollBar, wxScrolled, wxScrollWinEvent

Reimplemented in wxScrollBar.

## ◆ SetScrollPos()

virtual void wxWindow::SetScrollPos | ( | int | orientation,
|  | int | pos,
|  | bool | refresh = `true`
| ) |  |
| virtual

Sets the position of one of the built-in scrollbars.

Parameters

  orientation | Determines the scrollbar whose position is to be set. May be wxHORIZONTAL or wxVERTICAL.
  pos | Position in scroll units.
  refresh | true to redraw the scrollbar, false otherwise.

Remarks
  This function does not directly affect the contents of the window: it is up to the application to take note of scrollbar attributes and redraw contents accordingly.

See also
  SetScrollbar(), GetScrollPos(), GetScrollThumb(), wxScrollBar, wxScrolled

## ◆ SetSize() [1/4]

void wxWindow::SetSize | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | int | sizeFlags = `wxSIZE_AUTO`
| ) |  |

Sets the size of the window in pixels.

Parameters

  x | Required x position in pixels, or wxDefaultCoord to indicate that the existing value should be used.
  y | Required y position in pixels, or wxDefaultCoord to indicate that the existing value should be used.
  width | Required width in pixels, or wxDefaultCoord to indicate that the existing value should be used.
  height | Required height position in pixels, or wxDefaultCoord to indicate that the existing value should be used.
  sizeFlags | Indicates the interpretation of other parameters. It is a bit list of the following: `wxSIZE_AUTO_WIDTH:` a wxDefaultCoord width value is taken to indicate a wxWidgets-supplied default width. `wxSIZE_AUTO_HEIGHT:` a wxDefaultCoord height value is taken to indicate a wxWidgets-supplied default height. `wxSIZE_AUTO:` wxDefaultCoord size values are taken to indicate a wxWidgets-supplied default size. `wxSIZE_USE_EXISTING:` existing dimensions should be used if wxDefaultCoord values are supplied. `wxSIZE_ALLOW_MINUS_ONE:` allow negative dimensions (i.e. value of wxDefaultCoord) to be interpreted as real dimensions, not default values. `wxSIZE_FORCE:` normally, if the position and the size of the window are already the same as the parameters of this function, nothing is done. but with this flag a window resize may be forced even in this case (supported in wx 2.6.2 and later and only implemented for MSW and ignored elsewhere currently).

Remarks
  This overload sets the position and optionally size, of the window. Parameters may be wxDefaultCoord to indicate either that a default should be supplied by wxWidgets, or that the current value of the dimension should be used.

See also
  Move(), Window Sizing Overview

## ◆ SetSize() [2/4]

void wxWindow::SetSize | ( | const wxRect & | rect | ) |

Sets the size of the window in pixels.

The size is specified using a wxRect, wxSize or by a couple of `int` objects.

Remarks
  This form must be used with non-default width and height values.

See also
  Move(), Window Sizing Overview

## ◆ SetSize() [3/4]

void wxWindow::SetSize | ( | const wxSize & | size | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ SetSize() [4/4]

void wxWindow::SetSize | ( | int | width,
|  | int | height
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ SetSizeHints() [1/2]

virtual void wxWindow::SetSizeHints | ( | const wxSize & | minSize,
|  | const wxSize & | maxSize = `wxDefaultSize`,
|  | const wxSize & | incSize = `wxDefaultSize`
| ) |  |
| virtual

Use of this function for windows which are not toplevel windows (such as wxDialog or wxFrame) is discouraged.

Please use SetMinSize() and SetMaxSize() instead.

See also
  wxTopLevelWindow::SetSizeHints, Window Sizing Overview

Reimplemented in wxTopLevelWindow.

## ◆ SetSizeHints() [2/2]

virtual void wxWindow::SetSizeHints | ( | int | minW,
|  | int | minH,
|  | int | maxW = `-1`,
|  | int | maxH = `-1`,
|  | int | incW = `-1`,
|  | int | incH = `-1`
| ) |  |
| virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Reimplemented in wxTopLevelWindow.

## ◆ SetSizer()

void wxWindow::SetSizer | ( | wxSizer * | sizer,
|  | bool | deleteOld = `true`
| ) |  |

Sets the window to have the given layout sizer.

The window will then own the object, and will take care of its deletion. If an existing layout constraints object is already owned by the window, it will be deleted if the deleteOld parameter is true.

Note that this function will also call SetAutoLayout() implicitly with true parameter if the sizer is non-NULL and false otherwise so that the sizer will be effectively used to layout the window children whenever it is resized.

Parameters

  sizer | The sizer to set. Pass NULL to disassociate and conditionally delete the window's sizer. See below.
  deleteOld | If true (the default), this will delete any pre-existing sizer. Pass false if you wish to handle deleting the old sizer yourself but remember to do it yourself in this case to avoid memory leaks.

Remarks
  SetSizer enables and disables Layout automatically.

## ◆ SetSizerAndFit()

void wxWindow::SetSizerAndFit | ( | wxSizer * | sizer,
|  | bool | deleteOld = `true`
| ) |  |

This method calls SetSizer() and then wxSizer::SetSizeHints which sets the initial window size to the size needed to accommodate all sizer elements and sets the size hints which, if this window is a top level one, prevent the user from resizing it to be less than this minimal size.

## ◆ SetThemeEnabled()

virtual void wxWindow::SetThemeEnabled | ( | bool | enable | ) |
| virtual

This function tells a window if it should use the system's "theme" code to draw the windows' background instead of its own background drawing code.

This does not always have any effect since the underlying platform obviously needs to support the notion of themes in user defined windows. One such platform is GTK+ where windows can have (very colourful) backgrounds defined by a user's selected theme.

Dialogs, notebook pages and the status bar have this flag set to true by default so that the default look and feel is simulated best.

## ◆ SetToolTip() [1/2]

void wxWindow::SetToolTip | ( | const wxString & | tipString | ) |

Attach a tooltip to the window.

wxToolTip pointer can be NULL in the overload taking the pointer, meaning to unset any existing tooltips; however UnsetToolTip() provides a more readable alternative to this operation.

Notice that these methods are always available, even if wxWidgets was compiled with `wxUSE_TOOLTIPS` set to 0, but don't do anything in this case.

See also
  GetToolTip(), wxToolTip

## ◆ SetToolTip() [2/2]

void wxWindow::SetToolTip | ( | wxToolTip * | tip | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ SetTransparent()

virtual bool wxWindow::SetTransparent | ( | wxByte | alpha | ) |
| virtual

Set the transparency of the window.

If the system supports transparent windows, returns true, otherwise returns false and the window remains fully opaque. See also CanSetTransparent().

The parameter alpha is in the range 0..255 where 0 corresponds to a fully transparent window and 255 to the fully opaque one. The constants `wxIMAGE_ALPHA_TRANSPARENT` and `wxIMAGE_ALPHA_OPAQUE` can be used.

Reimplemented in wxTopLevelWindow.

## ◆ SetValidator()

virtual void wxWindow::SetValidator | ( | const wxValidator & | validator | ) |
| virtual

Deletes the current validator (if any) and sets the window validator, having called wxValidator::Clone to create a new validator of this type.

## ◆ SetVirtualSize() [1/2]

void wxWindow::SetVirtualSize | ( | int | width,
|  | int | height
| ) |  |

Sets the virtual size of the window in pixels.

See also
  Window Sizing Overview

## ◆ SetVirtualSize() [2/2]

void wxWindow::SetVirtualSize | ( | const wxSize & | size | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ SetWindowStyle()

void wxWindow::SetWindowStyle | ( | long | style | ) |

See SetWindowStyleFlag() for more info.

## ◆ SetWindowStyleFlag()

virtual void wxWindow::SetWindowStyleFlag | ( | long | style | ) |
| virtual

Sets the style of the window.

Please note that some styles cannot be changed after the window creation and that Refresh() might need to be called after changing the others for the change to take place immediately.

See Window styles for more information about flags.

See also
  GetWindowStyleFlag()

Reimplemented in wxListCtrl, and wxAuiToolBar.

## ◆ SetWindowVariant()

void wxWindow::SetWindowVariant | ( | wxWindowVariant | variant | ) |

Chooses a different variant of the window display to use.

Window variants currently just differ in size, as can be seen from wxWindowVariant documentation. Under all platforms but OS X, this function does nothing more than change the font used by the window. However under OS X it is implemented natively and selects the appropriate variant of the native widget, which has better appearance than just scaled down or up version of the normal variant, so it should be preferred to directly tweaking the font size.

By default the controls naturally use the normal variant.

## ◆ ShouldInheritColours()

virtual bool wxWindow::ShouldInheritColours | ( |  | ) | const
| virtual

Return true from here to allow the colours of this window to be changed by InheritAttributes().

Returning false forbids inheriting them from the parent window.

The base class version returns false, but this method is overridden in wxControl where it returns true.

Reimplemented in wxRichTextCtrl.

## ◆ Show()

virtual bool wxWindow::Show | ( | bool | show = `true` | ) |
| virtual

Shows or hides the window.

You may need to call Raise() for a top level window if you want to bring it to top, although this is not needed if Show() is called immediately after the frame creation.

Notice that the default state of newly created top level windows is hidden (to allow you to create their contents without flicker) unlike for all the other, not derived from wxTopLevelWindow, windows that are by default created in the shown state.

Parameters

  show | If true displays the window. Otherwise, hides it.

Returns
  true if the window has been shown or hidden or false if nothing was done because it already was in the requested state.

See also
  IsShown(), Hide(), wxRadioBox::Show, wxShowEvent.

Reimplemented in wxDialog, and wxAuiMDIChildFrame.

## ◆ ShowWithEffect()

virtual bool wxWindow::ShowWithEffect | ( | wxShowEffect | effect,
|  | unsigned int | timeout = `0`
| ) |  |
| virtual

This function shows a window, like Show(), but using a special visual effect if possible.

Parameters

  effect | The effect to use.
  timeout | The timeout parameter specifies the time of the animation, in milliseconds. If the default value of 0 is used, the default animation time for the current platform is used.

Note
  Currently this function is only implemented in wxMSW and wxOSX (for wxTopLevelWindows only in Carbon version and for any kind of windows in Cocoa) and does the same thing as Show() in the other ports.

Since
  2.9.0

See also
  HideWithEffect()

## ◆ Thaw()

void wxWindow::Thaw | ( |  | ) |

Re-enables window updating after a previous call to Freeze().

To really thaw the control, it must be called exactly the same number of times as Freeze().

If the window has any children, they are recursively thawed too.

See also
  wxWindowUpdateLocker, Freeze(), IsFrozen()

## ◆ ToggleWindowStyle()

bool wxWindow::ToggleWindowStyle | ( | int | flag | ) |

Turns the given flag on if it's currently turned off and vice versa.

This function cannot be used if the value of the flag is 0 (which is often the case for default flags).

Also, please notice that not all styles can be changed after the control creation.

Returns
  Returns true if the style was turned on by this function, false if it was switched off.

See also
  SetWindowStyleFlag(), HasFlag()

## ◆ TransferDataFromWindow()

virtual bool wxWindow::TransferDataFromWindow | ( |  | ) |
| virtual

Transfers values from child controls to data areas specified by their validators.

Returns false if a transfer failed.

If the window has `wxWS_EX_VALIDATE_RECURSIVELY` extra style flag set, the method will also call TransferDataFromWindow() of all child windows.

See also
  TransferDataToWindow(), wxValidator, Validate()

## ◆ TransferDataToWindow()

virtual bool wxWindow::TransferDataToWindow | ( |  | ) |
| virtual

Transfers values to child controls from data areas specified by their validators.

If the window has `wxWS_EX_VALIDATE_RECURSIVELY` extra style flag set, the method will also call TransferDataToWindow() of all child windows.

Returns
  Returns false if a transfer failed.

See also
  TransferDataFromWindow(), wxValidator, Validate()

## ◆ UnregisterHotKey()

virtual bool wxWindow::UnregisterHotKey | ( | int | hotkeyId | ) |
| virtual

Unregisters a system wide hotkey.

Parameters

  hotkeyId | Numeric identifier of the hotkey. Must be the same id that was passed to RegisterHotKey().

Returns
  true if the hotkey was unregistered successfully, false if the id was invalid.

Remarks
  This function is currently only implemented under MSW.

See also
  RegisterHotKey()

## ◆ UnreserveControlId()

static void wxWindow::UnreserveControlId | ( | wxWindowID | id,
|  | int | count = `1`
| ) |  |
| static

Unreserve an ID or range of IDs that was reserved by NewControlId().

See Window IDs for more information.

Parameters

  id | The starting ID of the range of IDs to unreserve.
  count | The number of sequential IDs to unreserve.

See also
  NewControlId(), wxIdManager, Window IDs

## ◆ UnsetToolTip()

void wxWindow::UnsetToolTip | ( |  | ) |

Unset any existing tooltip.

Since
  2.9.0

See also
  SetToolTip()

## ◆ Update()

virtual void wxWindow::Update | ( |  | ) |
| virtual

Calling this method immediately repaints the invalidated area of the window and all of its children recursively (this normally only happens when the flow of control returns to the event loop).

Notice that this function doesn't invalidate any area of the window so nothing happens if nothing has been invalidated (i.e. marked as requiring a redraw). Use Refresh() first if you want to immediately redraw the window unconditionally.

## ◆ UpdateWindowUI()

virtual void wxWindow::UpdateWindowUI | ( | long | flags = `wxUPDATE_UI_NONE` | ) |
| virtual

This function sends one or more wxUpdateUIEvent to the window.

The particular implementation depends on the window; for example a wxToolBar will send an update UI event for each toolbar button, and a wxFrame will send an update UI event for each menubar menu item.

You can call this function from your application to ensure that your UI is up-to-date at this point (as far as your wxUpdateUIEvent handlers are concerned). This may be necessary if you have called wxUpdateUIEvent::SetMode() or wxUpdateUIEvent::SetUpdateInterval() to limit the overhead that wxWidgets incurs by sending update UI events in idle time. flags should be a bitlist of one or more of the wxUpdateUI enumeration.

If you are calling this function from an OnInternalIdle or OnIdle function, make sure you pass the wxUPDATE_UI_FROMIDLE flag, since this tells the window to only update the UI elements that need to be updated in idle time. Some windows update their elements only when necessary, for example when a menu is about to be shown. The following is an example of how to call UpdateWindowUI from an idle function.

void MyWindow::OnInternalIdle()
{
if (wxUpdateUIEvent::CanUpdate(this))
UpdateWindowUI(wxUPDATE_UI_FROMIDLE);
}

See also
  wxUpdateUIEvent, DoUpdateWindowUI(), OnInternalIdle()

## ◆ UseBgCol()

bool wxWindow::UseBgCol | ( |  | ) | const

Return true if a background colour has been set for this window.

## ◆ Validate()

virtual bool wxWindow::Validate | ( |  | ) |
| virtual

Validates the current values of the child controls using their validators.

If the window has `wxWS_EX_VALIDATE_RECURSIVELY` extra style flag set, the method will also call Validate() of all child windows.

Returns
  Returns false if any of the validations failed.

See also
  TransferDataFromWindow(), TransferDataToWindow(), wxValidator

## ◆ WarpPointer()

virtual void wxWindow::WarpPointer | ( | int | x,
|  | int | y
| ) |  |
| virtual

Moves the pointer to the given position on the window.

Note
  Apple Human Interface Guidelines forbid moving the mouse cursor programmatically so you should avoid using this function in Mac applications (and probably avoid using it under the other platforms without good reason as well).

Parameters

  x | The new x position for the cursor.
  y | The new y position for the cursor.

## ◆ WindowToClientSize()

virtual wxSize wxWindow::WindowToClientSize | ( | const wxSize & | size | ) | const
| virtual

Converts window size size to corresponding client area size In other words, the returned value is what would GetClientSize() return if this window had given window size.

Components with wxDefaultCoord value are left unchanged.

Note that the conversion is not always exact, it assumes that non-client area doesn't change and so doesn't take into account things like menu bar (un)wrapping or (dis)appearance of the scrollbars.

Since
  2.8.8

See also
  ClientToWindowSize()